SketchMorph subclass: #BarEmblem
	instanceVariableNames: 'menu mFlg barFlg '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 03:34'!
acceptDroppingMorph: aMorph event: evt
	Sensor shiftPressed ifTrue:[
		(aMorph isKindOf: SketchMorph)
		ifTrue: [
			self form: aMorph form]
		ifFalse: [
			self form: aMorph imageForm
	]].
	aMorph rejectDropMorphEvent: evt.! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 02:09'!
bottomBar
	owner bottomLeft: (0@World height) .
	owner comeToFront.
	owner menu bottomLeft: self topCenter.
	owner menu comeToFront.
	barFlg _ 1.! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 00:20'!
handlesMouseDown: anEvent
	anEvent yellowButtonPressed ifTrue: [ ^true ].
	anEvent redButtonPressed ifTrue: [ ^ true].
	^super handlesMouseDown: anEvent! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 01:39'!
hideFlap
	CurrentProjectRefactoring currentToggleFlapsSuppressed! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 02:01'!
initialize
	| f |
	super initialize.

	f _ FormCanvas extent: 46@46.
	self form: f form.
	f fillColor: Color white.
	f fillOval: ((1@1 corner: self extent) insetBy: 2) color: Color gray.
	f fillOval: ((1@1 corner: self extent) insetBy: 10) color: Color white.
	f fillOval: ((1@1 corner: self extent) insetBy: 16) color: Color black.
	f frameOval: ((1@1 corner: self extent) insetBy: 2) width: 1 color: Color black.
	self form: f form.
	barFlg _ 0.
	
! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/26/2004 23:30'!
mFlg
	^ mFlg! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/26/2004 23:31'!
mFlg: aNum
	mFlg _ aNum! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 02:05'!
mouseDown: evt
	self on: #startDrag send: #grabMorph: to: owner owner.
	evt hand waitForClicksOrDrag: self event: evt.

	evt yellowButtonPressed
		ifTrue: [ self optionMenu ].
	evt redButtonPressed
		ifTrue: [
			mFlg = 0 
			ifTrue: [
				owner menu show.
				owner menu comeToFront.
				barFlg = 0 
				ifTrue: [
					owner menu position: self bottomCenter]
				ifFalse: [
					owner menu bottomLeft: self topCenter].
				mFlg _ 1]
			ifFalse: [
				owner menu hide.
				mFlg _ 0].
		]
	"super mouseDown: evt"! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 00:30'!
nomalEmblem! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 01:50'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'topBar' target: self action: #topBar.
	aMenu add: 'bottomBar' target: self action: #bottomBar.
	aMenu addLine.
	aMenu add: 'thumbnail emblem' target: self action: #thumbnailEmblem.
	aMenu add: 'nomal emblem' target: self action: #nomalEmblem.
	aMenu addLine.
	aMenu add: 'Flap ON/OFF' target: self action: #hideFlap.
	aMenu popUpInWorld: World
! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 00:29'!
thumbnailEmblem! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 02:10'!
topBar
	owner position: 0@0.
	owner comeToFront.
	owner menu position: self bottomCenter.
	owner menu comeToFront.
	barFlg _ 0.! !

!BarEmblem methodsFor: 'as yet unclassified' stamp: 'ty 7/25/2004 14:19'!
wantsDroppedMorph: aMorph event: evt
	^ true.! !


SketchMorph subclass: #BoxIcon
	instanceVariableNames: 'icon sFlg openPt closePt '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 03:17'!
acceptDroppingMorph: aMorph event: evt
	Sensor shiftPressed ifTrue:[
		(aMorph isKindOf: SketchMorph)
		ifTrue: [
			self form: aMorph form]
		ifFalse: [
			self form: aMorph imageForm
	]].
	aMorph rejectDropMorphEvent: evt! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 04:07'!
changeName
	| newName |
	newName _ FillInTheBlank request: 'New Item Name:' initialAnswer: owner owner name contents.
	owner owner name contents: newName.! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/21/2004 21:26'!
closePt
	^ closePt! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/21/2004 21:33'!
closePt: aPoint
	closePt _ aPoint! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/6/2004 04:56'!
doubleClick: evt

	self on: #doubleClick send: #editWithEvent: to: self.
	self on: #startDrag send: #grabMorph: to: owner owner.

	owner owner comeToFront.
	Display restore.

	sFlg = 0 ifTrue: [
		closePt _ owner owner position.
		owner owner position: openPt.
		owner owner box hide.
		owner listDirection: #topToBottom.
		owner listCentering: #center.
		owner wrapCentering: #topToBottm.
		owner owner space extent:	10@1.
		sFlg _ 1]
	ifFalse: [
		openPt _ owner owner position.
		owner owner position: closePt.
		World addMorphFront: owner owner.
		owner owner box show.
		owner listDirection: #leftToRight.
		owner owner space extent: 10@10.
		sFlg _ 0].! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/25/2004 02:31'!
handlesMouseDown: anEvent
	anEvent yellowButtonPressed ifTrue: [ ^true ].
	anEvent redButtonPressed ifTrue: [ ^ true].
	^super handlesMouseDown: anEvent! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/21/2004 22:24'!
initialize
	| f |
	super initialize.

	f _ FormCanvas extent: 32@32.
	f fillColor: Color red.
	self form: f form.
	sFlg _ 0.
	openPt _ 20.
	closePt _ 20.! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/6/2004 04:59'!
lineLyout
	owner owner box toggleAutoLineLayout
! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/25/2004 02:30'!
mouseDown: evt
	self on: #startDrag send: #grabMorph: to: owner owner.
	evt hand waitForClicksOrDrag: self event: evt.

	evt yellowButtonPressed
		ifTrue: [ self optionMenu ].
	super mouseDown: evt

! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/21/2004 21:26'!
openPt
	^ openPt! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/21/2004 21:33'!
openPt: aPoint
	openPt _ aPoint! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 04:04'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'change name' target: self action: #changeName.
	aMenu add: 'thumbnail icon' target: self action: #thumIcon.
	aMenu add: 'autLineLayout' target: self action: #lineLyout.
	aMenu add: 'PartsBin' target: self action: #partsBin.
	aMenu popUpInWorld: World
! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 04:05'!
partsBin
	owner owner box toggleIsPartsBin! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 18:21'!
sFlg
	^ sFlg! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/24/2004 23:36'!
thumIcon
	| if tb |
	if _ owner owner box imageForm.
	tb _ (Thumbnail new maxWidth: 50 minHeight: 40)  makeThumbnailFromForm: if.
	self form: tb form.
!
]style[(19 1 54 26 30 21)f1b,f1,f1cblack;,f1bcblack;,f1cblack;,f1! !

!BoxIcon methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 19:00'!
wantsDroppedMorph: aMorph event: evt
	^ true.! !


PasteUpMorph subclass: #ColorPalette
	instanceVariableNames: 'colorBox sliderR sliderG sliderB sliderA textR textG textB textA chipBox picker '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:53'!
chipBox
	^ chipBox! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:52'!
colorBox
	^ colorBox! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/6/2004 03:41'!
colorValueA: aValue
	textA contents: 'A: ' , (aValue roundTo: 0.01)  asString.
	colorBox color: (Color 
						r: colorBox color red 
						g: colorBox color green 
						b: colorBox color blue
						alpha: (aValue roundTo: 0.01)).
! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/6/2004 03:37'!
colorValueB: aValue
	textB contents: 'B: ' , (aValue roundTo: 0.01)  asString.
	colorBox color: (Color 
						r: colorBox color red
						g: colorBox color green
						b: (aValue roundTo: 0.01)
						alpha: colorBox color alpha).
! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/6/2004 03:37'!
colorValueG: aValue
	textG contents: 'G: ' , (aValue roundTo: 0.01)  asString.
	colorBox color: (Color 
						r: colorBox color red
						g: (aValue roundTo: 0.01)
						b: colorBox color blue
						alpha: colorBox color alpha).
! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/6/2004 03:36'!
colorValueR: aValue
	textR contents: 'R: ' , (aValue roundTo: 0.01)  asString.
	colorBox color: (Color 
						r: (aValue roundTo: 0.01) 
						g: colorBox color green 
						b: colorBox color blue
						alpha: colorBox color alpha).
! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 21:18'!
initialize
	| fc pickerColor |
	super initialize.
	self extent: 300@200.

	chipBox _ PasteUpMorph new.
	chipBox extent: 100@100.
	chipBox color: Color white.
	chipBox borderColor: Color gray.
	chipBox borderWidth: 1.
	chipBox layoutPolicy: TableLayout new.
	chipBox listDirection: #leftToRight.
	chipBox wrapDirection: #topToBottom.
	chipBox listCentering: #leftToRight.
	chipBox wrapCentering: #topToBottm.	
	chipBox layoutInset: 4.
	chipBox cellInset: 3.
	self addMorph: chipBox.
	chipBox align: chipBox topLeft with: self topLeft + (10@11).
	chipBox toggleStickiness.

	fc _ FormCanvas extent: 170@120.
	fc _ (Color colorTest: 32 extent: fc extent colorMapper: [:c | c]).
	picker _ SketchMorph withForm: fc form.
	picker on: #click send: #value to: [
		pickerColor _ (Display colorAt: Sensor cursorPoint).
		colorBox color: pickerColor.
		sliderR value: (pickerColor red roundTo: 0.001).
		textR contents: 'R: ' , (pickerColor red  roundTo: 0.001) asString.
		sliderG value: (pickerColor green roundTo: 0.001).
		textG contents: 'G: ' , (pickerColor green roundTo: 0.001) asString.
		sliderB value: (pickerColor blue roundTo: 0.001).
		textB contents: 'B: ' , (pickerColor blue roundTo: 0.001) asString.
		sliderA value: (pickerColor alpha roundTo: 0.001).
		textA contents: 'A: ' , (pickerColor alpha roundTo: 0.001) asString.
	].
	self addMorph: picker.
	picker align: picker topRight with: self topRight + (-10@-9).
	picker toggleStickiness.


	sliderR _ SimpleSliderMorph new.
	sliderR 
		minVal: 0.0;
		maxVal: 1.0;
		extent: 120@9;
		target: self;
		actionSelector: #colorValueR:;
		adjustToValue: 0.5.
	sliderR extent: 120@9.
	sliderR color: (Color r: 1.0 g: 0.839 b: 0.806).
	self addMorph: sliderR.
	sliderR align: sliderR bottomLeft with: self bottomLeft + (10@-60).
	sliderR toggleStickiness.
	textR _ TextMorph new.
	textR contents: 'R: 0.5'.
	textR wrapFlag: true.
	self addMorph: textR.
	textR align: textR topLeft with: sliderR topRight + (10@-5).
	textR toggleStickiness.

	sliderG _ SimpleSliderMorph new.
	sliderG 
		minVal: 0.0;
		maxVal: 1.0;
		extent: 120@9;
		target: self;
		actionSelector: #colorValueG:;
		adjustToValue: 0.5.
	sliderG extent: 120@9.
	sliderG color: (Color r: 0.71 g: 0.871 b: 0.613).
	self addMorph: sliderG.
	sliderG align: sliderG bottomLeft with: self bottomLeft + (10@-45).
	sliderG toggleStickiness.
	textG _ TextMorph new.
	textG contents: 'G: 0.5'.
	textG wrapFlag: true.
	self addMorph: textG.
	textG align: textG topLeft with: sliderG topRight + (10@-5).
	textG toggleStickiness.

	sliderB _ SimpleSliderMorph new.
	sliderB 
		minVal: 0.0;
		maxVal: 1.0;
		extent: 120@9;
		target: self;
		actionSelector: #colorValueB:;
		adjustToValue: 0.5.
	sliderB extent: 120@9.
	sliderB color: (Color r: 0.677 g: 0.806 b: 0.871).
	self addMorph: sliderB.
	sliderB align: sliderB bottomLeft with: self bottomLeft + (10@-30).
	sliderB toggleStickiness.
	textB _ TextMorph new.
	textB contents: 'B: 0.5'.
	textB wrapFlag: true.
	self addMorph: textB.
	textB align: textB topLeft with: sliderB topRight + (10@-5).
	textB toggleStickiness.

	sliderA _ SimpleSliderMorph new.
	sliderA 
		minVal: 0.0;
		maxVal: 1.0;
		extent: 120@9;
		target: self;
		actionSelector: #colorValueA:;
		adjustToValue: 1.0.
	sliderA extent: 120@9.
	sliderA color: (Color r: 0.839 g: 0.839 b: 0.839).
	self addMorph: sliderA.
	sliderA align: sliderA bottomLeft with: self bottomLeft + (10@-15).
	sliderA toggleStickiness.
	textA _ TextMorph new.
	textA contents: 'A: 1.0'.
	textA wrapFlag: true.
	self addMorph: textA.
	textA align: textA topLeft with: sliderA topRight + (10@-5).
	textA toggleStickiness.

	colorBox _ ToyColorRectangle new.
	colorBox extent: 60@60.
	colorBox borderWidth: 1.
	colorBox color: (Color r: 0.5 g: 0.5 b: 0.5 alpha: 1.0).
	self addMorph: colorBox.
	colorBox align: colorBox bottomRight with: self bottomRight + (-10@-15).
	colorBox toggleStickiness.

! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:53'!
picker
	^ picker! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:52'!
sliderA
	^ sliderA! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:52'!
sliderB
	^ sliderB! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:52'!
sliderG
	^ sliderG! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:52'!
sliderR
	^ sliderR! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:53'!
textA
	^ textA! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:53'!
textB
	^ textB! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:53'!
textG
	^ textG! !

!ColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 16:52'!
textR
	^ textR! !


BoxIcon subclass: #DeckIcon
	instanceVariableNames: 'editFlg '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!DeckIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 04:48'!
editFlg
	^ editFlg! !

!DeckIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 03:11'!
editOnOff
	editFlg = 0
	ifTrue: [
		owner owner footer hide.
		owner owner box height: owner owner box height - 30.
		owner owner shadeButton position: owner owner box position.
		owner owner shadeButton show.
		owner owner shadeButton comeToFront.
		editFlg _ 1]
	ifFalse: [
		owner owner footer show.
		owner owner box height: owner owner box height + 30.
		owner owner shadeButton position: owner owner box position + (-1000@1000).
		owner owner shadeButton hide.
		editFlg _ 0].! !

!DeckIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 23:42'!
initialize
	super initialize.
	editFlg _ 0.! !

!DeckIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 23:41'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'change name' target: self action: #changeName.
	aMenu add: 'thumbnail icon' target: self action: #thumIcon.
	aMenu add: 'edit ON/OFF' target: self action: #editOnOff.
	aMenu popUpInWorld: World
! !


RectangleMorph subclass: #ToyBar
	instanceVariableNames: 'emblem menu pm '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyBar methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 04:28'!
initialize
	super initialize.
	self color: Color white.
	self borderColor: Color black.
	self borderWidth: 1.
	self left: World left.
	self width: World width.
	self height: 46.
	self position: 0@0.

	emblem _ BarEmblem new.
	emblem position: 5@0.
	self addMorph: emblem.
	emblem mFlg: 0.

	menu _ ToyMenu new openInWorld.
	menu position: emblem bottomLeft + (0@1).
	menu hide.

	pm _ PasteUpMorph new.
	pm color: (Color yellow alpha: 0.04).
	pm borderWidth: 1.
	pm borderColor: (Color gray alpha: 0.3).
	pm extent: (World width - emblem width - 10)@self height.
	pm position: (emblem width + 10)@0.
	pm toggleAutoLineLayout.
	pm listDirection: #rightToLeft.
	pm cellInset: 5@5.
	pm layoutInset: 6@3.
	pm wrapCentering: #center.
	pm changeClipSubmorphs.
	self addMorph: pm.

	"self setToAdhereToEdge: #topLeft."
	self toggleStickiness.
	self changeClipSubmorphs.! !

!ToyBar methodsFor: 'as yet unclassified' stamp: 'ty 7/26/2004 23:26'!
menu
	^ menu! !

!ToyBar methodsFor: 'as yet unclassified' stamp: 'ty 7/28/2004 01:47'!
ownerChanged
	self width: World width.
	pm width: self width - emblem width - 10.
	pm height: self height.! !


Morph subclass: #ToyBoard
	instanceVariableNames: 'icon name box space header '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyBoard methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 19:21'!
box
	^ box! !

!ToyBoard methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 19:09'!
header
	^ header! !

!ToyBoard methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 19:09'!
icon
	^ icon! !

!ToyBoard methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 04:10'!
initialize
	| fc |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ PartsBin new.
	box extent: 300@200.
	box color: (Color white alpha: 0.5).
	box borderColor: Color black.
	box borderWidth: 1.
	box toggleAutoLineLayout.
	self addMorph: box.

	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'NewBoard'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ BoxIcon new.
	fc _ FormCanvas extent: 30@36.
	fc fillRectangle: ((0@0) corner: (30@36)) color: Color white.
	fc frameRectangle: ((0@0) corner: (30@36)) width: 2 color: Color black.
	fc frameRectangle: ((4@4) corner: (26@32)) width: 1 color: Color lightGray.
	fc frameRectangle: ((8@0) corner: (22@8)) width: 2 color: Color black.
	icon form: fc form.
	header addMorph: icon.

! !

!ToyBoard methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 04:09'!
name
	^ name! !

!ToyBoard methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 19:09'!
space
	^ space! !


Morph subclass: #ToyBox
	instanceVariableNames: 'icon name box space header '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyBox methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 18:10'!
box
	^ box! !

!ToyBox methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 18:18'!
header
	^ header! !

!ToyBox methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 18:18'!
icon
	^ icon! !

!ToyBox methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 04:10'!
initialize
	| fc |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ PasteUpMorph new.
	box extent: 300@200.
	box color: Color white.
	box borderColor: Color black.
	box borderWidth: 1.
	self addMorph: box.

	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'NewBox'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ BoxIcon new.
	fc _ FormCanvas extent: 37@31.
	fc line: 1@15 to: 36@15 width: 1 color: Color lightGray.
	fc line: 5@1to: 31@1 width: 2 color: Color black.
	fc line: 5@1 to: 1@15 width: 2 color: Color black.
	fc line: 31@1 to: 36@15 width: 2 color: Color black.
	fc line: 1@15 to: 1@30 width: 2 color: Color black.
	fc line: 1@30 to: 36@30 width: 2 color: Color black.
	fc line: 36@15 to: 36@30 width: 2 color: Color black.
	fc line: 13@22 to: 23@22 width: 2 color: Color black.
	fc form shapeFill: Color white interiorPoint: (10@10).
	fc form shapeFill: Color white interiorPoint: (10@20).
	icon form: fc form.
	header addMorph: icon.
! !

!ToyBox methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 04:09'!
name
	^ name! !

!ToyBox methodsFor: 'as yet unclassified' stamp: 'ty 7/15/2004 18:16'!
space
	^ space! !


SketchMorph subclass: #ToyButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 03:17'!
acceptDroppingMorph: aMorph event: evt
	Sensor shiftPressed ifTrue:[
		(aMorph isKindOf: SketchMorph)
		ifTrue: [
			self form: aMorph form]
		ifFalse: [
			self form: aMorph imageForm
	]].
	aMorph rejectDropMorphEvent: evt! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:33'!
doubleClick: evt

	self on: #doubleClick send: #editWithEvent: to: self.
	"self on: #startDrag send: #grabMorph: to: self."

	evt yellowButtonPressed
	ifTrue: [].
! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:32'!
handlesMouseDown: anEvent
	anEvent yellowButtonPressed ifTrue: [ ^true ].
	anEvent redButtonPressed ifTrue: [ ^ true].
	^super handlesMouseDown: anEvent! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 01:33'!
initialize
	| f |
	super initialize.

	f _ FormCanvas extent: 40@40.
	self form: f form.
	f fillOval: ((0@0 corner: self extent) insetBy: 2) color: Color white.
	f frameOval: ((0@0 corner: self extent) insetBy: 2) width: 2 color: Color black.
	f drawString: 'BTN' at: 10@14 font: nil color: Color black.
	self form: f form.! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:33'!
mouseDown: evt
	self on: #startDrag send: #grabMorph: to: self.
	evt hand waitForClicksOrDrag: self event: evt.

	evt yellowButtonPressed
		ifTrue: [ self optionMenu ].

	super mouseDown: evt! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:33'!
mouseUpAction
	self addMouseUpAction! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:33'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'mouseUpAction' target: self action: #mouseUpAction.
	aMenu popUpInWorld: World
! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 03:59'!
programmedMouseDown: anEvent for: aMorph

	aMorph addMouseActionIndicatorsWidth: 2 color: (Color r: 1.0 g: 0.5 b: 1.0 alpha: 0.4).
! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 03:56'!
programmedMouseEnter: anEvent for: aMorph

	aMorph addMouseActionIndicatorsWidth: 4 color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.3).
! !

!ToyButton methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 01:02'!
wantsDroppedMorph: aMorph event: evt
	^ true.! !


Morph subclass: #ToyCalender
	instanceVariableNames: 'box header icon space name cal todayStock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 16:06'!
box
	^ box! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 05:57'!
cal
	^ cal! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 05:08'!
changeDay
	"| fDay fBlank n |
	fDay _ Date today  month  next firstDate weekday.
	fBlank _ Date dayOfWeek: fDay.
	n _ 1.
	lDay _ Date today month duration.

	tc box submorphsDo: [: r1 | 
		(r1 = (tc box submorphs at: 1)) | (r1 = (tc box submorphs at: 8))
		ifFalse: [
			r1 submorphsDo: [: r2 | 
				(r2 submorphs at: 1) contents: (n - fBlank) asString wrappedTo: 15 .
				(n > fBlank) & (n <= (lDay + fBlank)) ifFalse: [
				(r2 submorphs at: 1) contents: '  ' wrappedTo: 15].
				n _ n + 1.
		]
	]].
	tc setToday."! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 16:06'!
header
	^ header! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 16:06'!
icon
	^ icon! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 04:49'!
initialize
	| fc |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ PasteUpMorph new.
	box extent: 300@200.
	box color: Color white.
	box borderColor: Color black.
	box borderWidth: 1.
	box layoutPolicy: TableLayout new.
	box layoutInset: 0@0.
	box changeListDirection: #topToBottom.
	self addMorph: box.

	todayStock _ Date today.
	self makeDayBox.
	self setToday.

	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'ToyCalender'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ ToyIcon new.
	fc _ FormCanvas extent: 36@36.
	fc fillOval: ((0@0) corner: (36@36)) color: (Color white).
	fc frameOval: ((0@0) corner: (36@36)) color: (Color black).
	fc fillOval: ((1@1) extent: (28@28)) color: (Color gray).
	fc frameOval: ((1@1) extent: (28@28)) color: (Color black).	
	icon form: fc form.
	header addMorph: icon.
! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/18/2004 17:19'!
makeDayBox
	| fDay fBlank lDay m w d wl dl st n |
	fDay _ Date today month firstDate weekday.
	fBlank _ Date dayOfWeek: fDay.
	lDay _ Date today month duration.

	n _ 1.

	6 timesRepeat: [
		w _ RectangleMorph new.
		w extent: 300@30.
		w color: Color transparent.
		w borderWidth: 0.
		w layoutPolicy: TableLayout new.
		w listDirection: #leftToRight.
		w hResizing: #spaceFill.
		w vResizing: #spaceFill.
		box addMorph: w.
		w goBehind.
		w toggleStickiness.

		7 timesRepeat: [
			d _ RectangleMorph new.
			d extent: 30@30.
			d color: Color transparent.
			d borderWidth: 1.
			d setBorderStyle: #complexRaised.
			d layoutPolicy: TableLayout new.
			d layoutInset: (2@-2).
			d hResizing: #spaceFill.
			d vResizing: #spaceFill.

			st _ TextMorph new.
			st contents: (n - fBlank) asString wrappedTo: 15 .
			(n > fBlank) & (n <= (lDay + fBlank)) ifFalse: [
			st contents: '  ' wrappedTo: 15 .].
			st lockUnlockMorph.
			n _ n + 1.
			d addMorph: st.

			w addMorph: d.
			d goBehind.
			d toggleStickiness.
		].
	].
	n _ 1.
	wl _ RectangleMorph new.
	wl extent: 300@10.
	wl color: Color transparent.
	wl borderWidth: 0.
	wl layoutPolicy: TableLayout new.
	wl listDirection: #leftToRight.
	wl hResizing: #spaceFill.
	"wl vResizing: #spaceFill."
	box addMorph: wl.
	wl toggleStickiness.

	7 timesRepeat: [
		dl _ RectangleMorph new.
		dl extent: 30@30.
		dl color: Color transparent.
		dl borderWidth: 0.
		dl hResizing: #spaceFill.
		dl vResizing: #spaceFill.
		st _ TextMorph new.
		st contents: ({'sun'. 'mon'. 'tue'. 'wed'. 'thu'. 'fri'. 'sat'.} at: n) wrappedTo: 25 .
		st textColor: Color gray.
		st lockUnlockMorph.
		n _ n + 1.
		dl addMorph: st.
		st align: st topLeft with: dl topLeft + (2@-2).
		wl addMorph: dl.
		dl goBehind.
		dl toggleStickiness.
	].

	m _ RectangleMorph new.
	m extent: 300@30.
	m color: Color transparent.
	m borderWidth: 0.
	m borderColor: (Color r: 0.9 g: 0.9 b: 0.9).
	m hResizing: #spaceFill.
	box addMorph: m.
	m goBehind.
	m toggleStickiness.

	st _ TextMorph new.
	st contents: 'JUN'.
	st fontName: #NewYork size: 18.
	m addMorph: st.
	st align: st center with: (m center).
	st lockUnlockMorph.

! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 16:06'!
name
	^ name! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 05:08'!
setToday

	box submorphsDo: [: r1 | 
	(r1 = (box submorphs at: 1)) | (r1 = (box submorphs at: 8))
	ifFalse: [
		r1 submorphsDo: [: r2 | 
			r2 color: Color transparent.
			r2 borderWidth: 1.
			r2 setBorderStyle: #complexRaised
	]]].
box submorphsDo: [: r1 | 
	r1 submorphsDo: [: r2 | 
		(r2 submorphs at: 1) contents = todayStock dayOfMonth asString
		ifTrue: [ 
				r2 color: (Color r: 0.92 g: 0.92 b: 1.0).
				r2 borderWidth: 1.
				r2 setBorderStyle: #inset.
				^ r2]
]].
! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 16:07'!
space
	^ space! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 04:46'!
step

	"todayStock = Date today
		ifFalse: [self changeDay.
				today _ Date today]"! !

!ToyCalender methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 04:46'!
stepTime
	^ 3000! !


RectangleMorph subclass: #ToyColorChip
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 03:01'!
acceptDroppingMorph: aMorph event: evt
	self color: aMorph color.
	aMorph rejectDropMorphEvent: evt! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:36'!
colorInfo
FillInTheBlank
		request: 'Color RGB value is....'
		initialAnswer: '(Color   r: ' , (self color red roundTo: 0.001) asString , (Character cr asString),(Character tab asString),(Character tab asString), 
							'g: ' , (self color red roundTo: 0.001) asString , (Character cr asString),(Character tab asString),(Character tab asString), 
							'b: ' , (self color red roundTo: 0.001) asString , (Character cr asString),(Character tab asString),(Character tab asString), 
							'alpha: ' ,(self color red roundTo: 0.001) asString , ')'! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 02:53'!
handlesMouseDown: anEvt 
	anEvt yellowButtonPressed
		ifTrue: [^ true].
	anEvt redButtonPressed
		ifTrue: [^ true].
	^ super handlesMouseDown: anEvt! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 04:45'!
handlesMouseUp: evt 
	^ true! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 02:45'!
initialize
	super initialize.

	self extent: 20@20.
	self color: Color white.
	self borderWidth: 1.! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:24'!
mouseDown: anEvt
	| s |
	self on: #startDrag send: #grabMorph: to: self.
	anEvt hand waitForClicksOrDrag: self event: anEvt.

	anEvt yellowButtonPressed ifTrue: [
		self optionMenu 
	].

	anEvt redButtonPressed ifTrue: [
		self owner submorphs do: [ :morph | 
			(self bounds intersects: morph bounds) ifTrue: [ 
				s _ morph.
				s == self ifFalse: [
					s color: self color].
			]
		]
	].
	super mouseDown: anEvt! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:24'!
mouseUp: evt
	Sensor shiftPressed ifTrue:[
		ColorPickerMorph new
 			choseModalityFromPreference;
 			sourceHand: self activeHand;
 			target: self;
 			selector: #fillStyle:;
 			originalColor: self color;
 			putUpFor: self near: self fullBoundsInWorld
	]! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:24'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'world BG color' target: self action: #worldBgColor.
	aMenu add: 'color info' target: self action: #colorInfo.
	aMenu popUpInWorld: World! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 03:00'!
wantsDroppedMorph: aMorph event: evt
	^ true.! !

!ToyColorChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:25'!
worldBgColor
	World color: self color! !


Morph subclass: #ToyColorPalette
	instanceVariableNames: 'icon name box space header '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 15:40'!
box
	^ box! !

!ToyColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 15:39'!
header
	^ header! !

!ToyColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 15:39'!
icon
	^ icon! !

!ToyColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 03:20'!
initialize
	| fc |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ ColorPalette new.
	box extent: 300@200.
	box color: Color white.
	box borderColor: Color black.
	box borderWidth: 1.
	self addMorph: box.

	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'ToyColorPalette'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ ToyIcon new.
	fc _ FormCanvas extent: 46@36.
	fc fillOval: ((0@0) corner: (46@36)) color: (Color white).
	fc frameOval: ((0@0) corner: (46@36)) color: (Color black).
	fc fillOval: ((8@18) extent: (12@12)) color: (Color transparent).
	fc frameOval: ((8@18) extent: (12@12)) color: (Color black).
	fc form shapeFill: Color transparent interiorPoint: 10@20.
	fc fillOval: ((17@4) extent: (6@6)) color: (Color gray).
	fc fillOval: ((28@7) extent: (6@6)) color: (Color gray).
	fc fillOval: ((36@14) extent: (6@6)) color: (Color gray).
	icon form: fc form.
	header addMorph: icon.
! !

!ToyColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 15:40'!
name
	^ name! !

!ToyColorPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/5/2004 15:40'!
space
	^ space! !


RectangleMorph subclass: #ToyColorPlate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyColorPlate methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 05:40'!
handlesMouseDown: evt 
	^ true! !

!ToyColorPlate methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 05:38'!
initialize
	super initialize.

	self extent: 100@100.
	self color: Color transparent.
	self borderWidth: 1.! !

!ToyColorPlate methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 05:52'!
mouseDown: evt
	| col tc |
	col _ Display colorAt: evt position.
	tc _ ToyColorChip new.
	tc color: col.
	tc openInHand.
! !


RectangleMorph subclass: #ToyColorRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyColorRectangle methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 21:33'!
acceptDroppingMorph: aMorph event: evt
	self color: aMorph color.

	owner sliderR value: (aMorph color red roundTo: 0.001).
	owner sliderR adjustToValue: owner sliderR value.
	owner textR contents: 'R: ' , (aMorph color red  roundTo: 0.001) asString.
	owner sliderG value: (aMorph color green roundTo: 0.001).
	owner sliderG adjustToValue: owner sliderG value.
	owner textG contents: 'G: ' , (aMorph color green  roundTo: 0.001) asString.
	owner sliderB value: (aMorph color blue roundTo: 0.001).
	owner sliderB adjustToValue: owner sliderB value.
	owner textB contents: 'B: ' , (aMorph color blue  roundTo: 0.001) asString.
	owner sliderA value: (aMorph color alpha roundTo: 0.001).
	owner sliderA adjustToValue: owner sliderA value.
	owner textA contents: 'A: ' , (aMorph color blue  roundTo: 0.001) asString.

	aMorph rejectDropMorphEvent: evt! !

!ToyColorRectangle methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 21:12'!
handlesMouseDown: evt 
	^ true! !

!ToyColorRectangle methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 21:16'!
initialize
	super initialize.

	self extent: 100@100.
	self color: Color transparent.
	self borderWidth: 1.! !

!ToyColorRectangle methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 21:15'!
mouseDown: evt
	| tc |
	tc _ ToyColorChip new.
	tc color: (Color r: owner sliderR value
					g: owner sliderG value
					b: owner sliderB value
					alpha: owner sliderA value).
	tc openInHand.
! !

!ToyColorRectangle methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 21:26'!
ownerChanged
	owner sliderR value: (self color red roundTo: 0.001).
	owner sliderR adjustToValue: owner sliderR value.
	owner textR contents: 'R: ' , (self color red  roundTo: 0.001) asString.
	owner sliderG value: (self color green roundTo: 0.001).
	owner sliderG adjustToValue: owner sliderG value.
	owner textG contents: 'G: ' , (self color green  roundTo: 0.001) asString.
	owner sliderB value: (self color blue roundTo: 0.001).
	owner sliderB adjustToValue: owner sliderB value.
	owner textB contents: 'B: ' , (self color blue  roundTo: 0.001) asString.
	owner sliderA value: (self color alpha roundTo: 0.001).
	owner sliderA adjustToValue: owner sliderA value.
	owner textA contents: 'A: ' , (self color blue  roundTo: 0.001) asString.
! !

!ToyColorRectangle methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 21:29'!
wantsDroppedMorph: aMorph event: evt
	^ true.! !


Morph subclass: #ToyDeck
	instanceVariableNames: 'icon name box space header footer pageBank pageNum page firstButton newButton nextButton deleteButton prevButton pageExtent shadeButton pageCountText '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 00:47'!
box
	^ box! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 21:18'!
deleteButton
	deleteButton! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 21:18'!
firstButton
	^ firstButton! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 21:23'!
footer
	^ footer! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 00:49'!
header
	^ header! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 00:49'!
icon
	^ icon! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 01:53'!
initialize
	| fc  oldPage r rm |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.
	
	pageExtent _ 300@200.

	box _ Morph new.
	box color: Color black.
	box extent: pageExtent + (0@30).
	self addMorph: box.

	pageBank _ OrderedCollection new.
	"-----------------------------------------------------"
	pageNum _ 1.
	page _ PasteUpMorph new.
	page extent: pageExtent.
	page color: Color white.
	page borderColor: Color black.
	page borderWidth: 1.
	pageBank addFirst: page.
	box addMorph: page.
	page position: box position.
	"-----------------------------------------------------"
	shadeButton _ Morph new.
	shadeButton color: Color transparent.
	shadeButton extent: pageExtent.
	shadeButton on: #click send: #value to: [
		Sensor cursorPoint x < (shadeButton width // 2 + shadeButton position)
		ifTrue: [
			pageBank at: pageNum put: page.
			pageNum _ (pageNum - 1).
			pageNum < 1
			ifTrue: [ pageNum _ pageBank size].
			oldPage _ page.
			page _ pageBank at: pageNum.
			box addMorph: page.
			oldPage delete.
			page position: box position.
			page extent: pageExtent.
			box extent: pageExtent.
			shadeButton comeToFront.
			pageCountText contents: 'P - ' , pageNum asString.
		]
		ifFalse: [
			pageBank at: pageNum put: page.
			pageNum _ pageNum + 1.
			pageNum > pageBank size
			ifTrue: [ pageNum _ 1].
			oldPage _ page.
			page _ pageBank at: pageNum.
			box addMorph: page.
			oldPage delete.
			page position: box position.
			page extent: pageExtent.
			box extent: pageExtent.
			shadeButton comeToFront.
			pageCountText contents: 'P - ' , pageNum asString.
		]
	].
	shadeButton position: box position + (-1000@1000).
	box addMorph: shadeButton.
	shadeButton hide.
	"-----------------------------------------------------"
	footer _ Morph new.
	footer color: Color transparent.
	footer layoutPolicy: TableLayout new.
	footer listDirection: #leftToRight.
	footer hResizing: #shrinkWrap.
	footer vResizing: #shrinkWrap.
	footer extent:  238@28.
	box addMorph: footer.
	footer align: footer center with: box bottomCenter + (0@-16).

	deleteButton _ PolygonMorph new openInWorld.
	deleteButton borderWidth: 1.
	deleteButton borderColor: Color black.
	deleteButton color: (Color r: 0.323 g: 0.548 b: 1.0).
	deleteButton setVertices: {0@0. 24@0. 24@10. 0@10.}.
	deleteButton on: #click send: #value to: [
		pageBank size > 1 ifTrue: [
			pageBank removeAt: pageNum.
			pageNum _ (pageNum - 1).
			pageNum < 1
			ifTrue: [ pageNum _ pageBank size].
			oldPage _ page.
			page _ pageBank at: pageNum.
			box addMorph: page.
			oldPage delete.
			page position: box position.
			page extent: pageExtent.
			box extent: pageExtent + (0@30).
			footer align: footer center with: box bottomCenter + (0@-16).
			pageCountText contents: 'P - ' , pageNum asString.]
	].
	footer addMorph: deleteButton.

	space _ Morph new.
	space extent: 25@10.
	space color: Color transparent.
	footer addMorph: space.

	nextButton _ PolygonMorph new openInWorld.
	nextButton borderWidth: 1.
	nextButton borderColor: Color black.
	nextButton color: (Color r: 1.0 g: 0.903 b: 0.0).
	nextButton setVertices: {0@0. 20@13. 0@26.}.
	nextButton on: #click send: #value to: [
		pageBank at: pageNum put: page.
		pageNum _ pageNum + 1.
		pageNum > pageBank size
		ifTrue: [ pageNum _ 1].
		oldPage _ page.
		page _ pageBank at: pageNum.
		box addMorph: page.
		oldPage delete.
		page position: box position.
		page extent: pageExtent.
		box extent: pageExtent + (0@30).
		footer align: footer center with: box bottomCenter + (0@-16).
			pageCountText contents: 'P - ' , pageNum asString.
	].
	footer addMorph: nextButton.

	space _ Morph new.
	space extent: 25@10.
	space color: Color transparent.
	footer addMorph: space.

	newButton _ PolygonMorph new openInWorld.
	newButton borderWidth: 1.
	newButton borderColor: Color red.
	newButton color: Color red.
	newButton setVertices: {0@0. 8@0. 8@-8. 16@-8. 16@0. 24@0. 24@8. 16@8. 16@16. 8@16. 8@8. 0@8.}.
	newButton on: #click send: #value to: [
		pageBank at: pageNum put: page.
		oldPage _ page.
		page _ PasteUpMorph new.
		page color: Color white.
		page borderColor: Color black.
		page extent: 300@200.
		pageBank add: page afterIndex: pageNum.
		pageNum _ pageNum + 1.
		box addMorph: page.
		oldPage delete.
		page position: box position.
		page extent: pageExtent.
		box extent: pageExtent + (0@30).
		footer align: footer center with: box bottomCenter + (0@-16).
		pageCountText contents: 'P - ' , pageNum asString.
	].
	footer addMorph: newButton.

	space _ Morph new.
	space extent: 25@10.
	space color: Color transparent.
	footer addMorph: space.

	prevButton _ PolygonMorph new openInWorld.
	prevButton borderWidth: 1.
	prevButton borderColor: Color black.
	prevButton color: (Color r: 0.129 g: 0.613 b: 0.0).
	prevButton setVertices: {0@0. 20@-13. 20@13.}.
	prevButton on: #click send: #value to: [
		pageBank at: pageNum put: page.
		pageNum _ (pageNum - 1).
		pageNum < 1
		ifTrue: [ pageNum _ pageBank size].
		oldPage _ page.
		page _ pageBank at: pageNum.
		box addMorph: page.
		oldPage delete.
		page position: box position.
		page extent: pageExtent.
		box extent: pageExtent + (0@30).
		footer align: footer center with: box bottomCenter + (0@-16).
		pageCountText contents: 'P - ' , pageNum asString.
	].
	footer addMorph: prevButton.

	space _ Morph new.
	space extent: 25@10.
	space color: Color transparent.
	footer addMorph: space.

	firstButton _ RectangleMorph new.
	firstButton extent: 10@22.
	firstButton color: (Color r: 0.774 g: 0.613 b: 1.0).
	firstButton borderColor: Color black.
	firstButton borderWidth: 1.
	r _ firstButton duplicate.
	firstButton addMorph: r.
	r align: r center with: firstButton center + (12@0).
	firstButton on: #click send: #value to: [
		pageNum > 1 ifTrue: [
			pageBank at: pageNum put: page.
			pageNum _ 1.
			oldPage _ page.
			page _ pageBank at: pageNum.
			box addMorph: page.
			oldPage delete.
			page position: box position.
			page extent: pageExtent.
			box extent: pageExtent + (0@30).
			footer align: footer center with: box bottomCenter + (0@-16).
			pageCountText contents: 'P - ' , pageNum asString.]
	].
	footer addMorph: firstButton.

	pageCountText _ StringMorph new.
	pageCountText fontName: #NewYork size: 18.
	pageCountText color: (Color r: 0.6 g: 0.6 b: 0.6).
	pageCountText font: (TextStyle default fontAt: 2) emphasis: 1.
	pageCountText contents: 'P - 1'.
	rm _ Morph new.
	rm extent: 45@ 10.
	rm color: Color transparent.
	rm addMorph: pageCountText.
	pageCountText position: rm position + (0@-3).
	footer addMorph: rm.
	"-----------------------------------------------------"
	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'NewDeck'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ DeckIcon new.
	fc _ FormCanvas extent: 36@26.
	fc fillRectangle: ((6@6) extent: (30@20)) color: Color white.
	fc frameRectangle: ((6@6) extent: (30@20)) width: 2 color: Color gray.
	fc fillRectangle: ((3@3) extent: (30@20)) color: Color white.
	fc frameRectangle: ((3@3) extent: (30@20)) width: 2 color: Color gray.
	fc fillRectangle: ((0@0) extent: (30@20)) color: Color white.
	fc frameRectangle: ((0@0) extent: (30@20)) width: 2 color: Color black.
	icon form: fc form.
	header addMorph: icon.
	"-----------------------------------------------------"! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 00:49'!
name
	^ name! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 04:27'!
newButton
	^ newButton! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 04:26'!
nextButton
	^ nextButton! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/4/2004 01:54'!
ownerChanged
	pageExtent _ page extent.
	icon editFlg = 0
	ifTrue: [box extent: pageExtent + (0@30).
			footer align: footer center with: box bottomCenter + (0@-16).
			shadeButton extent: pageExtent].
	

! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 01:47'!
page
	^ page! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 01:49'!
page: aMorph
	page _ aMorph! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 04:41'!
pageBank
	^ pageBank! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 23:20'!
pageCountText
	^ pageCountText! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 02:34'!
pageExtent
	^ pageExtent! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 01:47'!
pageNum
	^ pageNum! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 01:43'!
pageNum: aNum
	pageNum _ aNum! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 04:26'!
prevButton
	^ prevButton! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 03:10'!
shadeButton
	^ shadeButton! !

!ToyDeck methodsFor: 'as yet unclassified' stamp: 'ty 8/2/2004 00:49'!
space
	^ space! !


BoxIcon subclass: #ToyIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 21:27'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'change name' target: self action: #changeName.
	aMenu add: 'thumbnail icon' target: self action: #thumIcon.
	aMenu popUpInWorld: World! !


RectangleMorph subclass: #ToyLayoutChip
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyLayoutChip methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 04:24'!
handlesMouseDown: anEvt 
	anEvt yellowButtonPressed
		ifTrue: [^ true].
	anEvt redButtonPressed
		ifTrue: [^ true].
	^ super handlesMouseDown: anEvt! !

!ToyLayoutChip methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 04:25'!
handlesMouseUp: evt 
	^ true! !

!ToyLayoutChip methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 05:22'!
initialize
	super initialize.

	self extent: 20@20.
	self color: (Color blue alpha: 0.2).
	self borderWidth: 1.
	self borderColor: Color blue.! !

!ToyLayoutChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:43'!
mouseDown: anEvt
	| s |
	self on: #startDrag send: #grabMorph: to: self.
	anEvt hand waitForClicksOrDrag: self event: anEvt.

	anEvt yellowButtonPressed ifTrue: [
		self optionMenu 
	].

	anEvt redButtonPressed ifTrue: [
		self owner submorphs do: [ :morph | 
			(self bounds intersects: morph bounds) ifTrue: [ 
				s _ morph.
				s == self ifFalse: [
					s enableDragNDrop: true.
					s layoutPolicy: TableLayout new.
					s layoutInset: self layoutInset.
					s cellInset: self cellInset.
					s changeListDirection: self listDirection.
					s wrapDirection: self wrapDirection.
					s listCentering: self listCentering.
					s wrapCentering: self wrapCentering.
					s hResizing: self hResizing.
					s vResizing: self vResizing.
				].
			]
		]
	].
	super mouseDown: anEvt! !

!ToyLayoutChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:14'!
mouseUp: evt
! !

!ToyLayoutChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:43'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'world BG layout' target: self action: #worldBgLayout.
	aMenu popUpInWorld: World! !

!ToyLayoutChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:45'!
worldBgLayout
	World enableDragNDrop: true.
	World layoutPolicy: TableLayout new.
	World layoutInset: self layoutInset.
	World cellInset: self cellInset.
	World changeListDirection: self listDirection.
	World wrapDirection: self wrapDirection.
	World listCentering: self listCentering.
	World wrapCentering: self wrapCentering.
	World hResizing: self hResizing.
	World vResizing: self vResizing.! !


Morph subclass: #ToyLayoutPalette
	instanceVariableNames: 'box header icon space name editBox layoutInsetText cellInsetText listDirectBtn1 listDirectBtn2 listDirectBtn3 listDirectBtn4 wrapDirectBtn1 wrapDirectBtn2 wrapDirectBtn3 wrapDirectBtn4 listCenterBtn1 listCenterBtn2 listCenterBtn3 listCenterBtn4 wrapCenterBtn1 wrapCenterBtn2 wrapCenterBtn3 wrapCenterBtn4 shrinkWBtn1 shrinkWBtn2 shrinkWBtn3 selectBox1 selectBox2 selectBox3 selectBox4 selectBox5 selectBox6 selectBox7 tileBox layoutInsetHandle cellInsetHandle '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 01:43'!
box
	^ box! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/11/2004 16:36'!
editBox
	^ editBox! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 01:44'!
header
	^ header! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 01:43'!
icon
	^ icon! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 01:45'!
initialize
	| fc |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ RectangleMorph new.
	box extent: 300@200.
	box color: Color white.
	box borderColor: Color black.
	box borderWidth: 1.
	self addMorph: box.

	self makeEditBox.
	self makeTileBox.
	self makeListDirectBox.
	self makeWrapDirectBox.
	self makeListCenterBox.
	self makeWrapCenterBox.
	self makeShrinkBox.

	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'ToyLayoutPalette'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ ToyIcon new.
	fc _ FormCanvas extent: 40@40.
	fc fillRectangle: ((0@0) corner: (40@40)) color: Color white.
	fc frameRectangle: ((0@0) corner: (40@40)) width: 2 color: Color black.
	fc frameRectangle: ((22@6) extent: (12@12)) width: 1 color: Color lightGray.
	fc frameRectangle: ((6@6) extent: (12@12)) width: 1 color: Color lightGray.
	fc frameRectangle: ((6@22) extent: (12@12)) width: 1 color: Color lightGray.
	fc frameRectangle: ((22@22) extent: (12@12)) width: 1 color: Color lightGray.
	icon form: fc form.
	header addMorph: icon.
! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 05:11'!
makeEditBox
	| dumy numText n  handle1 handle2 |
	editBox _ RectangleMorph new.
	editBox extent: 170@150.
	editBox color: Color white.
	editBox borderColor: Color black.
	editBox borderWidth: 1.
	editBox changeClipSubmorphs.
	editBox layoutPolicy: TableLayout new.
	editBox listDirection: #leftToRight.
	editBox wrapDirection: #topToBottom.
	box addMorph: editBox.
	editBox align: editBox topLeft with: box topLeft + (5@5).
	
	n _ 16.
	16 timesRepeat: [
		dumy _ RectangleMorph new.
		dumy extent: 20@20.
		dumy color: Color transparent.
		dumy borderColor: Color black.
		dumy borderWidth: 1.
		editBox addMorph: dumy.
		numText _ StringMorph new.
		numText contents: n asString.
		dumy addMorph: numText.
		numText align: numText center with: dumy center + (0@0).
		n _ n - 1].

	layoutInsetText _ TextMorph new.
	layoutInsetText contents: 'layoutIncet: 0'.
	layoutInsetText wrapFlag: true.
	box addMorph: layoutInsetText.
	layoutInsetText lockUnlockMorph.
	layoutInsetText align: layoutInsetText topLeft with: editBox bottomLeft + (55@4).

	layoutInsetHandle _ EllipseMorph new.
	layoutInsetHandle extent: 8@8.
	layoutInsetHandle on: #mouseDown send: #value to: [
		handle1 _ HandleMorph new forEachPointDo:
			[:newPoint | editBox layoutInset: (newPoint - layoutInsetHandle center asIntegerPoint) // 4.
				layoutInsetText contents: 'layoutIncet: ' , ((newPoint - layoutInsetHandle center asIntegerPoint) // 5) asString].
	World activeHand attachMorph: handle1.
	handle1 startStepping
	].
	box addMorph: layoutInsetHandle.
	layoutInsetHandle align: layoutInsetHandle topLeft with: editBox bottomLeft + (43@8).

	cellInsetText _ TextMorph new.
	cellInsetText contents: 'cellInset: 0'.
	cellInsetText wrapFlag: true.
	box addMorph: cellInsetText.
	cellInsetText lockUnlockMorph.
	cellInsetText align: cellInsetText topLeft with: editBox bottomLeft + (55@22).

	cellInsetHandle _ EllipseMorph new.
	cellInsetHandle extent: 8@8.
	cellInsetHandle on: #mouseDown send: #value to: [
		handle2 _ HandleMorph new forEachPointDo:
			[:newPoint | editBox cellInset: (newPoint - cellInsetHandle center asIntegerPoint) // 4.
				cellInsetText contents: 'cellIncet: ' , ((newPoint - cellInsetHandle center asIntegerPoint) // 5) asString].
	World activeHand attachMorph: handle2.
	handle2 startStepping
	].
	box addMorph: cellInsetHandle.
	cellInsetHandle align: cellInsetHandle topLeft with: editBox bottomLeft + (43@26).! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 03:13'!
makeListCenterBox
	| text rm1 rm2 rm3 rm4 rm5 |
	text _ TextMorph new.
	text contents: 'listCentering'.
	text wrapFlag: true.
	box addMorph: text.
	text lockUnlockMorph.
	text align: text topLeft with: editBox topRight + (15@69).

	listCenterBtn1 _ RectangleMorph new.
	listCenterBtn1 extent: 20@20.
	listCenterBtn1 color: Color transparent.
	listCenterBtn1 borderColor: Color black.
	listCenterBtn1 borderWidth: 1.
	box addMorph: listCenterBtn1.
	listCenterBtn1 align: listCenterBtn1 topLeft with: editBox topRight + (15@85).

	listCenterBtn1 on: #click send: #value to: [
		editBox listCentering: #topLeft
	].

	rm1 _ RectangleMorph new.
	rm1 extent: 9@9.
	rm1 color: Color black.
	rm1 borderColor: Color black.
	rm1 borderWidth: 1.
	listCenterBtn1 addMorph: rm1.
	rm1 align: rm1 topLeft with: listCenterBtn1 topLeft.

	listCenterBtn2 _ RectangleMorph new.
	listCenterBtn2 extent: 20@20.
	listCenterBtn2 color: Color transparent.
	listCenterBtn2 borderColor: Color black.
	listCenterBtn2 borderWidth: 1.
	box addMorph: listCenterBtn2.
	listCenterBtn2 align: listCenterBtn2 topLeft with: listCenterBtn1 topRight + (5@0).

	listCenterBtn2 on: #click send: #value to: [
		editBox listCentering: #bottomToRight
	].

	rm2 _ rm1 duplicate.
	listCenterBtn2 addMorph: rm2.
	rm2 align: rm2 bottomRight with: listCenterBtn2 bottomRight.

	listCenterBtn3 _ RectangleMorph new.
	listCenterBtn3 extent: 20@20.
	listCenterBtn3 color: Color transparent.
	listCenterBtn3 borderColor: Color black.
	listCenterBtn3 borderWidth: 1.
	box addMorph: listCenterBtn3.
	listCenterBtn3 align: listCenterBtn3 topLeft with: listCenterBtn2 topRight + (5@0).

	listCenterBtn3 on: #click send: #value to: [
		editBox listCentering: #center
	].

	rm3 _ rm1 duplicate.
	listCenterBtn3 addMorph: rm3.
	rm3 align: rm3 center with: listCenterBtn3 center.

	listCenterBtn4 _ RectangleMorph new.
	listCenterBtn4 extent: 20@20.
	listCenterBtn4 color: Color transparent.
	listCenterBtn4 borderColor: Color black.
	listCenterBtn4 borderWidth: 1.
	box addMorph: listCenterBtn4.
	listCenterBtn4 align: listCenterBtn4 topLeft with: listCenterBtn3 topRight + (5@0).

	listCenterBtn4 on: #click send: #value to: [
		editBox listCentering: #justified
	].

	rm4 _ rm1 duplicate.
	rm4 height: 3.
	rm5 _ rm4 duplicate.
	listCenterBtn4 addMorph: rm4.
	listCenterBtn4 addMorph: rm5.
	rm4 align: rm4 center with: listCenterBtn4 center + (0@-3).
	rm5 align: rm5 center with: listCenterBtn4 center + (0@3).! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 03:03'!
makeListDirectBox
	| text pm1 pm2 pm3 pm4 |
	text _ TextMorph new.
	text contents: 'listDirection'.
	text wrapFlag: true.
	box addMorph: text.
	text lockUnlockMorph.
	text align: text topLeft with: editBox topRight + (15@-3).

	listDirectBtn1 _ RectangleMorph new.
	listDirectBtn1 extent: 20@20.
	listDirectBtn1 color: Color transparent.
	listDirectBtn1 borderColor: Color black.
	listDirectBtn1 borderWidth: 1.
	box addMorph: listDirectBtn1.
	listDirectBtn1 align: listDirectBtn1 topLeft with: editBox topRight + (15@13).

	listDirectBtn1 on: #click send: #value to: [
		editBox changeListDirection: #leftToRight
	].

	pm1 _ PolygonMorph new.
	pm1 color: Color black.
	pm1 borderColor: Color black.
	pm1 borderWidth: 1.
	pm1 setVertices: {0@0. 4@-8. 8@0.}.
	pm1 heading: 90.
	listDirectBtn1 addMorph: pm1.
	pm1 center: listDirectBtn1 center.

	listDirectBtn2 _ RectangleMorph new.
	listDirectBtn2 extent: 20@20.
	listDirectBtn2 color: Color transparent.
	listDirectBtn2 borderColor: Color black.
	listDirectBtn2 borderWidth: 1.
	box addMorph: listDirectBtn2.
	listDirectBtn2 align: listDirectBtn2 topLeft with: listDirectBtn1 topRight + (5@0).

	listDirectBtn2 on: #click send: #value to: [
		editBox changeListDirection: #rightToLeft
	].

	pm2 _ pm1 duplicate.
	pm2 heading: -90.
	listDirectBtn2 addMorph: pm2.
	pm2 center: listDirectBtn2 center.

	listDirectBtn3 _ RectangleMorph new.
	listDirectBtn3 extent: 20@20.
	listDirectBtn3 color: Color transparent.
	listDirectBtn3 borderColor: Color black.
	listDirectBtn3 borderWidth: 1.
	box addMorph: listDirectBtn3.
	listDirectBtn3 align: listDirectBtn3 topLeft with: listDirectBtn2 topRight + (5@0).

	listDirectBtn3 on: #click send: #value to: [
		editBox changeListDirection: #topToBottom
	].

	pm3 _ pm1 duplicate.
	pm3 heading: 180.
	listDirectBtn3 addMorph: pm3.
	pm3 center: listDirectBtn3 center.

	listDirectBtn4 _ RectangleMorph new.
	listDirectBtn4 extent: 20@20.
	listDirectBtn4 color: Color transparent.
	listDirectBtn4 borderColor: Color black.
	listDirectBtn4 borderWidth: 1.
	box addMorph: listDirectBtn4.
	listDirectBtn4 align: listDirectBtn4 topLeft with: listDirectBtn3 topRight + (5@0).

	listDirectBtn4 on: #click send: #value to: [ 
		editBox changeListDirection: #bottomToTop
	].

	pm4 _ pm1 duplicate.
	pm4 heading: 0.
	listDirectBtn4 addMorph: pm4.
	pm4 center: listDirectBtn4 center.! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 05:17'!
makeShrinkBox
	| text pm1 pm2 pm3 pm4 |
	text _ TextMorph new.
	text contents: 'ShrinkWrap'.
	text wrapFlag: true.
	box addMorph: text.
	text lockUnlockMorph.
	text align: text topLeft with: editBox topRight + (15@150).

	shrinkWBtn1 _ RectangleMorph new.
	shrinkWBtn1 extent: 10@20.
	shrinkWBtn1 color: Color transparent.
	shrinkWBtn1 borderColor: Color black.
	shrinkWBtn1 borderWidth: 1.
	box addMorph: shrinkWBtn1.
	shrinkWBtn1 align: shrinkWBtn1 topLeft with: editBox topRight + (23@168).

	shrinkWBtn1 on: #click send: #value to: [
		editBox hResizing: #shrinkWrap 
	].

	pm1 _ PolygonMorph new.
	pm1 color: Color black.
	pm1 borderColor: Color black.
	pm1 borderWidth: 1.
	pm1 setVertices: {0@0. 4@-6. 8@0.}.
	pm1 heading: 90.
	shrinkWBtn1 addMorph: pm1.
	pm1 center: shrinkWBtn1 center - (8@0).

	pm2 _ pm1 duplicate.
	pm2 heading: -90.
	shrinkWBtn1 addMorph: pm2.
	pm2 center: shrinkWBtn1 center + (8@0).

	shrinkWBtn2 _ RectangleMorph new.
	shrinkWBtn2 extent: 20@10.
	shrinkWBtn2 color: Color transparent.
	shrinkWBtn2 borderColor: Color black.
	shrinkWBtn2 borderWidth: 1.
	box addMorph: shrinkWBtn2.
	shrinkWBtn2 align: shrinkWBtn2 topLeft with: shrinkWBtn1 topRight + (20@4).

	shrinkWBtn2 on: #click send: #value to: [
		editBox vResizing: #shrinkWrap 
	].

	pm3 _ pm1 duplicate.
	pm3 heading: 180.
	shrinkWBtn2 addMorph: pm3.
	pm3 center: shrinkWBtn2 center - (0@8).

	pm4 _ pm1 duplicate.
	pm4 heading: 0.
	shrinkWBtn2 addMorph: pm4.
	pm4 center: shrinkWBtn2 center + (0@8).

	shrinkWBtn3 _ RectangleMorph new.
	shrinkWBtn3 extent: 20@20.
	shrinkWBtn3 color: Color transparent.
	shrinkWBtn3 borderColor: Color black.
	shrinkWBtn3 borderWidth: 1.
	box addMorph: shrinkWBtn3.
	shrinkWBtn3 align: shrinkWBtn3 topLeft with: shrinkWBtn2 topRight + (17@-6).

	shrinkWBtn3 on: #click send: #value to: [
		editBox vResizing: #rigid.
		editBox hResizing: #rigid.
		editBox extent: 170@150.
	].! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 05:10'!
makeTileBox
	| tc rm |
	tileBox _ RectangleMorph new.
	tileBox extent: 36@36.
	tileBox color: Color white.
	tileBox borderColor: Color black.
	tileBox borderWidth: 1.
	tileBox on: #mouseDown send: #value to: [
		tc _ ToyLayoutChip new.
		tc layoutInset: editBox layoutInset.
		tc cellInset: editBox cellInset.
		tc changeListDirection: editBox listDirection.
		tc wrapDirection: editBox wrapDirection.
		tc listCentering: editBox listCentering.
		tc wrapCentering: editBox wrapCentering.
		tc hResizing: editBox hResizing.
		tc vResizing: editBox vResizing.
		tc openInHand.
	].

	box addMorph: tileBox.
	tileBox align: tileBox topLeft with: editBox bottomLeft + (0@3).

	rm _ RectangleMorph new.
	rm extent: 20@20.
	rm color: Color white.
	rm borderColor: Color lightGray.
	rm borderWidth: 1.
	tileBox addMorph: rm.
	rm align: rm center with: tileBox center.! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 03:28'!
makeWrapCenterBox
	| text rm1 rm2 rm3 rm4 rm5 |
	text _ TextMorph new.
	text contents: 'wrapCentering'.
	text wrapFlag: true.
	box addMorph: text.
	text lockUnlockMorph.
	text align: text topLeft with: editBox topRight + (15@105).

	wrapCenterBtn1 _ RectangleMorph new.
	wrapCenterBtn1 extent: 20@20.
	wrapCenterBtn1 color: Color transparent.
	wrapCenterBtn1 borderColor: Color black.
	wrapCenterBtn1 borderWidth: 1.
	box addMorph: wrapCenterBtn1.
	wrapCenterBtn1 align: wrapCenterBtn1 topLeft with: editBox topRight + (15@121).

	wrapCenterBtn1 on: #click send: #value to: [
		editBox wrapCentering: #topLeft
	].

	rm1 _ RectangleMorph new.
	rm1 extent: 9@9.
	rm1 color: Color black.
	rm1 borderColor: Color black.
	rm1 borderWidth: 1.
	wrapCenterBtn1 addMorph: rm1.
	rm1 align: rm1 topLeft with: wrapCenterBtn1 topLeft.

	wrapCenterBtn2 _ RectangleMorph new.
	wrapCenterBtn2 extent: 20@20.
	wrapCenterBtn2 color: Color transparent.
	wrapCenterBtn2 borderColor: Color black.
	wrapCenterBtn2 borderWidth: 1.
	box addMorph: wrapCenterBtn2.
	wrapCenterBtn2 align: wrapCenterBtn2 topLeft with: wrapCenterBtn1 topRight + (5@0).

	wrapCenterBtn2 on: #click send: #value to: [
		editBox wrapCentering: #bottomToRight
	].

	rm2 _ rm1 duplicate.
	wrapCenterBtn2 addMorph: rm2.
	rm2 align: rm2 bottomRight with: wrapCenterBtn2 bottomRight.

	wrapCenterBtn3 _ RectangleMorph new.
	wrapCenterBtn3 extent: 20@20.
	wrapCenterBtn3 color: Color transparent.
	wrapCenterBtn3 borderColor: Color black.
	wrapCenterBtn3 borderWidth: 1.
	box addMorph: wrapCenterBtn3.
	wrapCenterBtn3 align: wrapCenterBtn3 topLeft with: wrapCenterBtn2 topRight + (5@0).

	wrapCenterBtn3 on: #click send: #value to: [
		editBox wrapCentering: #center
	].

	rm3 _ rm1 duplicate.
	wrapCenterBtn3 addMorph: rm3.
	rm3 align: rm3 center with: wrapCenterBtn3 center.

	wrapCenterBtn4 _ RectangleMorph new.
	wrapCenterBtn4 extent: 20@20.
	wrapCenterBtn4 color: Color transparent.
	wrapCenterBtn4 borderColor: Color black.
	wrapCenterBtn4 borderWidth: 1.
	box addMorph: wrapCenterBtn4.
	wrapCenterBtn4 align: wrapCenterBtn4 topLeft with: wrapCenterBtn3 topRight + (5@0).

	wrapCenterBtn4 on: #click send: #value to: [
		editBox wrapCentering: #justified
	].

	rm4 _ rm1 duplicate.
	rm4 height: 3.
	rm5 _ rm4 duplicate.
	wrapCenterBtn4 addMorph: rm4.
	wrapCenterBtn4 addMorph: rm5.
	rm4 align: rm4 center with: wrapCenterBtn4 center + (0@-3).
	rm5 align: rm5 center with: wrapCenterBtn4 center + (0@3).! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 03:06'!
makeWrapDirectBox
	| text pm1 pm2 pm3 pm4 |
	text _ TextMorph new.
	text contents: 'wrapDirection'.
	text wrapFlag: true.
	box addMorph: text.
	text lockUnlockMorph.
	text align: text topLeft with: editBox topRight + (15@33).

	wrapDirectBtn1 _ RectangleMorph new.
	wrapDirectBtn1 extent: 20@20.
	wrapDirectBtn1 color: Color transparent.
	wrapDirectBtn1 borderColor: Color black.
	wrapDirectBtn1 borderWidth: 1.
	box addMorph: wrapDirectBtn1.
	wrapDirectBtn1 align: wrapDirectBtn1 topLeft with: editBox topRight + (15@49).

	wrapDirectBtn1 on: #click send: #value to: [
		editBox wrapDirection: #leftToRight
	].

	pm1 _ PolygonMorph new.
	pm1 color: Color black.
	pm1 borderColor: Color black.
	pm1 borderWidth: 1.
	pm1 setVertices: {0@0. 4@-8. 8@0.}.
	pm1 heading: 90.
	wrapDirectBtn1 addMorph: pm1.
	pm1 center: wrapDirectBtn1 center.

	wrapDirectBtn2 _ RectangleMorph new.
	wrapDirectBtn2 extent: 20@20.
	wrapDirectBtn2 color: Color transparent.
	wrapDirectBtn2 borderColor: Color black.
	wrapDirectBtn2 borderWidth: 1.
	box addMorph: wrapDirectBtn2.
	wrapDirectBtn2 align: wrapDirectBtn2 topLeft with: wrapDirectBtn1 topRight + (5@0).

	wrapDirectBtn2 on: #click send: #value to: [
		editBox wrapDirection: #rightToLeft
	].

	pm2 _ pm1 duplicate.
	pm2 heading: -90.
	wrapDirectBtn2 addMorph: pm2.
	pm2 center: wrapDirectBtn2 center.

	wrapDirectBtn3 _ RectangleMorph new.
	wrapDirectBtn3 extent: 20@20.
	wrapDirectBtn3 color: Color transparent.
	wrapDirectBtn3 borderColor: Color black.
	wrapDirectBtn3 borderWidth: 1.
	box addMorph: wrapDirectBtn3.
	wrapDirectBtn3 align: wrapDirectBtn3 topLeft with: wrapDirectBtn2 topRight + (5@0).

	wrapDirectBtn3 on: #click send: #value to: [
		editBox wrapDirection: #topToBottom
	].

	pm3 _ pm1 duplicate.
	pm3 heading: 180.
	wrapDirectBtn3 addMorph: pm3.
	pm3 center: wrapDirectBtn3 center.

	wrapDirectBtn4 _ RectangleMorph new.
	wrapDirectBtn4 extent: 20@20.
	wrapDirectBtn4 color: Color transparent.
	wrapDirectBtn4 borderColor: Color black.
	wrapDirectBtn4 borderWidth: 1.
	box addMorph: wrapDirectBtn4.
	wrapDirectBtn4 align: wrapDirectBtn4 topLeft with: wrapDirectBtn3 topRight + (5@0).

	wrapDirectBtn4 on: #click send: #value to: [
		editBox wrapDirection: #bottomToTop
	].

	pm4 _ pm1 duplicate.
	pm4 heading: 0.
	wrapDirectBtn4 addMorph: pm4.
	pm4 center: wrapDirectBtn4 center.! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 01:43'!
name
	^ name! !

!ToyLayoutPalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 01:44'!
space
	^ space! !


PasteUpMorph subclass: #ToyMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyMenu methodsFor: 'as yet unclassified' stamp: 'ty 7/27/2004 05:12'!
initialize
	super initialize.
	self color: (Color white alpha: 0.5).
	self extent: 100@200.
	self borderColor: Color black.
	self borderWidth: 1.

	self layoutPolicy: TableLayout new.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.
	self cellPositioning: #topLeft.	
	"base vResizing: #shrinkWrap."

! !


RectangleMorph subclass: #ToyMenuItem
	instanceVariableNames: 'icon name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/31/2004 03:19'!
acceptDroppingMorph: aMorph event: evt
	Sensor shiftPressed ifTrue:[
		(aMorph isKindOf: SketchMorph)
		ifTrue: [
			icon form: aMorph form.
			self height: icon height + 2]
		ifFalse: [
			icon form: aMorph imageForm.
			self height: icon height + 2
	]].

	aMorph rejectDropMorphEvent: evt! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:23'!
changeName
	| newName |
newName _ FillInTheBlank request: 'New Item Name:' initialAnswer: name contents.
	name contents: newName.! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:25'!
deleteIcon
	| fc |
	fc _ FormCanvas extent: 2@16.
	fc fillColor: Color white.
	icon form: fc form.
	self height: icon height + 2.! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:28'!
doubleClick: evt

	self on: #doubleClick send: #editWithEvent: to: self.
	self on: #startDrag send: #grabMorph: to: self.

	evt yellowButtonPressed
	ifTrue: [
		].
! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 04:46'!
handlesMouseDown: anEvent
	anEvent yellowButtonPressed ifTrue: [ ^true ].
	anEvent redButtonPressed ifTrue: [ ^ true].
	^super handlesMouseDown: anEvent! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 04:55'!
initialize
	| fc |
	super initialize.
	self color: Color transparent.
	self borderColor: Color black.
	self borderWidth: 1.
	self extent: 120@18.
	"self toggleAutoLineLayout."
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self layoutInset: 0@0.
	self cellInset: 4@4.
	"self changeDragAndDrop."

	name _ TextMorph new.
	name contents: 'Menu Item'.
	"name wrapFlag: true."
	self addMorph: name.
	name lockUnlockMorph.

	icon _ SketchMorph new.
	fc _ FormCanvas extent: 2@16.
	fc fillColor: Color white.
	icon form: fc form.
	self addMorph: icon.! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:12'!
mouseDown: evt
	self on: #startDrag send: #grabMorph: to: self.
	evt hand waitForClicksOrDrag: self event: evt.

	evt yellowButtonPressed
		ifTrue: [ self optionMenu ].

	super mouseDown: evt! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:29'!
mouseUpAction
	self addMouseUpAction! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:28'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'mouseUpAction' target: self action: #mouseUpAction.
	aMenu add: 'changeName' target: self action: #changeName.
	aMenu add: 'deleteIcon' target: self action: #deleteIcon.
	aMenu popUpInWorld: World
! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:02'!
programmedMouseDown: anEvent for: aMorph

	aMorph addMouseActionIndicatorsWidth: 0 color: (Color r: 1.0 g: 0.5 b: 1.0 alpha: 0.4).
! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 05:02'!
programmedMouseEnter: anEvent for: aMorph

	aMorph addMouseActionIndicatorsWidth: 0 color: (Color r: 0.5 g: 0.5 b: 1.0 alpha: 0.3).
! !

!ToyMenuItem methodsFor: 'as yet unclassified' stamp: 'ty 7/29/2004 04:48'!
wantsDroppedMorph: aMorph event: evt
	^ true.! !


Morph subclass: #ToyPad
	instanceVariableNames: 'icon name box text pocket space header '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyPad methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 05:11'!
box
	^ box! !

!ToyPad methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 05:12'!
header
	^ header! !

!ToyPad methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 05:12'!
icon
	^ icon! !

!ToyPad methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 15:04'!
initialize
	| fc model |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ RectangleMorph new.
	box extent: 300@200.
	box color: Color white.
	box borderColor: Color black.
	box borderWidth: 1.
	self addMorph: box.

	box layoutPolicy: TableLayout new.
	box listDirection: #topToBottom.
	box listCentering: #center.
	box wrapCentering: #center.

	"----------------------------------------"
	model _ Workspace new.
	text _ PluggableTextMorph 
		on: model 
		text: #contents 
		accept: #contents:notifying:
		readSelection: #contentsSelection
		menu: #codePaneMenu:shifted:.
	text extent: 280@90.
	text color: Color white.
	box addMorph: text.

	space _ Morph new.
	space extent: 10@2.
	space color: Color transparent.
	box addMorph: space.

	pocket _ PasteUpMorph new.
	pocket extent: 280@90.
	pocket color:  (Color r: 1.0 g: 1.0 b: 0.903).
	pocket borderColor: Color black.
	pocket borderWidth: 1.
	box addMorph: pocket.
	"----------------------------------------"
	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'NewPad'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ BoxIcon new.
	fc _ FormCanvas extent: 30@36.
	fc fillRectangle: ((0@0) corner: (30@36)) color: Color white.
	fc frameRectangle: ((0@0) corner: (30@36)) width: 2 color: Color black.
	fc frameRectangle: ((4@4) corner: (26@17)) width: 1 color: Color lightGray.
	fc frameRectangle: ((4@19) corner: (26@32)) width: 1 color: Color lightGray.
	icon form: fc form.
	header addMorph: icon.
! !

!ToyPad methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 05:12'!
name
	^ name! !

!ToyPad methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 05:56'!
pocket
	^ pocket! !

!ToyPad methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 05:12'!
space
	^ space! !

!ToyPad methodsFor: 'as yet unclassified' stamp: 'ty 8/3/2004 15:31'!
text
	^ text! !


RectangleMorph subclass: #ToyStyleChip
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 17:11'!
acceptDroppingMorph: aMorph event: evt
	self color: aMorph color.
	self borderColor: aMorph borderColor.
	self borderWidth: aMorph borderWidth.
	self borderStyle: aMorph borderStyle.
	aMorph hasDropShadow
		ifTrue:[self hasDropShadow: true.
				self shadowOffset: aMorph shadowOffset.
				self shadowColor: aMorph shadowColor.
				self layoutChanged.
				self changed.]
		ifFalse:[self hasDropShadow: false].	

	aMorph rejectDropMorphEvent: evt! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 02:32'!
handlesMouseDown: anEvt 
	anEvt yellowButtonPressed
		ifTrue: [^ true].
	anEvt redButtonPressed
		ifTrue: [^ true].
	^ super handlesMouseDown: anEvt! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 02:34'!
handlesMouseUp: evt 
	^ true! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 02:19'!
initialize
	super initialize.

	self extent: 20@20.
	self color: Color white.
	self borderWidth: 1.! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:26'!
mouseDown: anEvt
	| s |
	self on: #startDrag send: #grabMorph: to: self.
	anEvt hand waitForClicksOrDrag: self event: anEvt.

	anEvt yellowButtonPressed ifTrue: [
		self optionMenu 
	].

	anEvt redButtonPressed ifTrue: [
		self owner submorphs do: [ :morph | 
			(self bounds intersects: morph bounds) ifTrue: [ 
				s _ morph.
				s == self ifFalse: [
					s color: self color.
					s borderColor: self borderColor.
					s borderWidth: self borderWidth.
					s borderStyle: self borderStyle.
					self hasDropShadow
					ifTrue:[s hasDropShadow: true.
						s shadowOffset: self shadowOffset.
						s shadowColor: self shadowColor.
						s layoutChanged.
						s changed.]
					ifFalse:[s hasDropShadow: false].
				]
			]
		]
	].
	super mouseDown: anEvt! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:16'!
mouseUp: evt
! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:41'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'world BG style' target: self action: #worldBgStyle.
	aMenu popUpInWorld: World! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:30'!
styleInfo
! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 02:19'!
wantsDroppedMorph: aMorph event: evt
	^ true.! !

!ToyStyleChip methodsFor: 'as yet unclassified' stamp: 'ty 8/13/2004 00:29'!
worldBgStyle
	World color: self color.
	World borderColor: self borderColor.
	World borderWidth: self borderWidth.
	World borderStyle: self borderStyle.
	self hasDropShadow
	ifTrue:[World hasDropShadow: true.
		World shadowOffset: self shadowOffset.
		World shadowColor: self shadowColor.
		World layoutChanged.
		World changed.]
	ifFalse:[World hasDropShadow: false].! !


Morph subclass: #ToyStylePalette
	instanceVariableNames: 'icon name box space header dumy colorBox1 colorBox2 borderBox shadowBox borderSlider shadowButton styleBox1 styleBox2 styleBox3 styleBox4 styleBox5 styleBox6 styleBox7 styleBox8 styleBox9 styleBox10 offsetHandle '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyMorph'!

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 22:27'!
borderBox
	^ borderBox! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/8/2004 22:24'!
borderSlider
	^ borderSlider! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/8/2004 21:24'!
box
	^ box! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 22:28'!
colorBox1
	^ colorBox1! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/8/2004 23:50'!
dumy
	^ dumy! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/8/2004 21:24'!
header
	^ header! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/8/2004 21:24'!
icon
	^ icon! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/12/2004 23:46'!
initialize
	| fc |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ PasteUpMorph new.
	box extent: 300@200.
	box color: Color white.
	box borderColor: Color black.
	box borderWidth: 1.
	self addMorph: box.

	self makeDumy.
	self makeColorBox1.
	"self makeColorBox2."
	self makeBorderBox.
	self makeBorderSlider.
	self makeShadowBox.
	self makeShadowButton.
	self makeStyleBox1.
	self makeStyleBox2.
	self makeStyleBox3.
	self makeStyleBox4.
	self makeStyleBox5.
	self makeStyleBox6.
	self makeStyleBox7.
	self makeStyleBox8.
	self makeStyleBox9.
	self makeStyleBox10.
	self makeOffsetHandle.

	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'ToyStylePalette'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ ToyIcon new.
	fc _ FormCanvas extent: 36@36.
	fc fillRectangle: ((6@6) corner: (36@36)) color: Color black.
	fc fillRectangle: ((0@0) corner: (32@32)) color: Color white.
	fc line: 0@32 to: 32@0 width: 1 color: Color gray.
	fc line: 32@0 to: 32@32 width: 1 color: Color gray.
	fc line: 32@32 to: 0@32 width: 1 color: Color gray.
	fc form shapeFill: (Color r: 0.7 g: 0.7 b: 0.7) interiorPoint: (30@10).
	fc frameRectangle: ((0@0) corner: (32@32)) width: 2 color: Color black.
	fc fillRectangle: ((7@7) corner: (25@25)) color: Color white.
	fc frameRectangle: ((7@7) corner: (25@25)) width: 2 color: Color black.
	icon form: fc form.
	header addMorph: icon.
! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/10/2004 00:44'!
makeBorderBox
	| text |
	borderBox _ ToyStyleRectangle new.
	borderBox extent: 20@20.
	borderBox borderWidth: 1.
	borderBox color: Color black.
	borderBox propFlg: 2.
	borderBox on: #click send: #value to: [
		ColorPickerMorph new
 			choseModalityFromPreference;
 			sourceHand: borderBox activeHand;
 			target: borderBox;
 			selector: #fillStyle:;
 			originalColor: borderBox color;
 			putUpFor: borderBox near: borderBox fullBoundsInWorld.
		dumy borderColor: borderBox color.
	].
	box addMorph: borderBox.
	borderBox align: borderBox topLeft with: box topLeft + (180@71).
	borderBox toggleStickiness.
	text _ TextMorph new.
	text contents: 'borderColor'.
	text wrapFlag: true.
	box addMorph: text.
	text align: text bottomLeft with: borderBox topLeft + (0@0).
	text toggleStickiness.! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/9/2004 05:25'!
makeBorderSlider
	| text |
	borderSlider _ SimpleSliderMorph new.
	borderSlider 
		minVal: 0;
		maxVal: 20;
		extent: 100@9;
		target: self;
		actionSelector: #widthValue:;
		adjustToValue: 5.
	borderSlider extent: 100@9.
	borderSlider color: (Color r: 0.839 g: 0.839 b: 0.839).
	box addMorph: borderSlider.
	borderSlider align: borderSlider topLeft with: borderBox bottomLeft + (0@3).
	borderSlider toggleStickiness.
	text _ TextMorph new.
	text contents: 'width'.
	text wrapFlag: true.
	box addMorph: text.
	text align: text bottomRight with: borderSlider topRight + (0@-1).
	text toggleStickiness.
! !

!ToyStylePalette methodsFor: 'as yet unclassified' stamp: 'ty 8/10/2004 00:43'!
makeColorBox1
	| text |
	colorBox1 _ ToyStyleRectangle new.
	colorBox1 extent: 20@20.
	colorBox1 borderWidth: 1.
	colorBox1 color: (Color r: 0.742 g: 0.774 b: 1.0).
	colorBox1 propFlg: 1.
	colorBox1 on: #click send: #value to: [
		ColorPickerMorph new
 			choseModalityFromPreference;
 			sourceHand: colorBox1 activeHand;
 			target: colorBox1;
 			selector: #fillStyle:;
 			originalColor: colorBox1 color;
 			putUpFor: colorBox1 near: colorBox1 fullBoundsInWorld.
		dumy color: colorBox1 color.
	].
	box addMorph: colorBox1.
	colorBox1 align: colorBox1 topLeft with: box topLeft + (180@28).
	colorBox1 toggleStickiness.
	text _ TextMorph new.
	text contents: 'color1st'.
	text wrapFlag: true.
	box addMorph: text.
	text align: text bottomLeft with: colorBox1 topLeft + (0@0).
	text toggleStickiness.!