BoxIcon subclass: #DropPicIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyTools'!

!DropPicIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:33'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'change name' target: self action: #changeName.
	aMenu add: 'thumbnail icon' target: self action: #thumIcon.
	aMenu addLine.
	aMenu add: 'change directory' target: self action: #setDirName.
	aMenu add: 'change fileName' target: self action: #setFileName.
	aMenu add: 'change fileType' target: self action: #setFileType.
	aMenu popUpInWorld: World! !

!DropPicIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:38'!
setDirName
	| newName |
	newName _ FillInTheBlank request: 'Directory Name:' initialAnswer: owner owner dirName.
	owner owner dirName: newName.! !

!DropPicIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:39'!
setFileName
	| newName |
	newName _ FillInTheBlank request: 'File Name:' initialAnswer: owner owner fileName.
	owner owner fileName: newName.! !

!DropPicIcon methodsFor: 'as yet unclassified' stamp: 'ty 8/19/2004 04:57'!
setFileType
	| aMenu |
	aMenu _ SelectionMenu 
		labelList: #( 'GIF' 'JPG' 'BMP' )
		selections: #( '.gif' '.jpeg' '.bmp' ).
	aMenu startUpWithCaption: 'change file type'.
	owner owner fileType: (aMenu selections at: aMenu selection).
! !


EllipseMorph subclass: #ToyAlignBtn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyTools'!

!ToyAlignBtn methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 16:46'!
doubleClick: evt
	"self on: #doubleClick send: #editWithEvent: to: self."
		"close bar"
		owner owner barFlg = 0
		ifTrue: [
			owner owner text1 hide.
			owner owner text2 hide.
			owner owner text3 hide.
			(owner owner rotateFlg = 0)
			ifTrue: [
				owner width: owner owner barWidth.
				owner width: owner owner shrinkWidth.
				self align: self center with: owner topRight]
			ifFalse: [
				owner height: owner owner barHeight.
				owner height: owner owner shrinkHeight.
				self align: self center with: owner bottomLeft].
		owner owner barFlg: 1
		]
		ifFalse: [
			owner owner text1 show.
			owner owner text2 show.
			owner owner text3 show.
			(owner owner rotateFlg = 0)
			ifTrue: [
				owner width: owner owner barWidth.
				owner owner text1 align: owner owner text1 center with: (owner left + 20)@(owner center y).
				owner owner text2 align: owner owner text2 center with: owner center.
				owner owner text3 align: owner owner text3 center with: (owner right - 20)@(owner center y).
				self align: self center with: owner topRight]
			ifFalse: [
				owner height: owner owner barHeight.
				owner owner text1 align: owner owner text1 center with: (owner center x)@(owner top + 20).
				owner owner text2 align: owner owner text2 center with: owner center.
				owner owner text3 align: owner owner text3 center with: (owner center x)@(owner bottom - 20).
				self align: self center with: owner bottomLeft].
		owner owner barFlg: 0
		]
! !

!ToyAlignBtn methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 04:55'!
handlesMouseDown: anEvent
	anEvent yellowButtonPressed ifTrue: [ ^true ].
	anEvent redButtonPressed ifTrue: [ ^ true].
	^super handlesMouseDown: anEvent! !

!ToyAlignBtn methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 05:00'!
mouseDown: evt
	evt hand waitForClicksOrDrag: self event: evt.

	"evt redButtonPressed
		ifTrue: [  ].
	super mouseDown: evt"! !

!ToyAlignBtn methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 04:46'!
mouseMove: evt
	owner owner barFlg = 0 ifTrue: [
		(owner owner rotateFlg = 0)
		ifTrue: [
			self center: (evt cursorPoint x)@(self center y).
			owner width: self center x - owner left.
			owner owner barWidth: owner width.
			owner owner text1 align: owner owner text1 center with: (owner left + 20)@(owner center y).
			owner owner text2 align: owner owner text2 center with: owner center.
			owner owner text3 align: owner owner text3 center with: (owner right - 20)@(owner center y)
		]
		ifFalse: [
			self center: (self center x)@(evt cursorPoint y).
			owner height: evt cursorPoint y - owner top.
			owner owner barHeight: owner height.
			owner owner text1 align: owner owner text1 center with: (owner center x)@(owner top + 20).
			owner owner text2 align: owner owner text2 center with: owner center.
			owner owner text3 align: owner owner text3 center with: (owner center x)@(owner bottom - 20)
		]
	]! !


EllipseMorph subclass: #ToyAlignment
	instanceVariableNames: 'case button1 button2 bar text1 text2 text3 barFlg barWidth barHeight rotateFlg shrinkHeight shrinkWidth '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyTools'!

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 17:41'!
bar
	^ bar! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/18/2004 01:58'!
barFat
	^ barFat! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/18/2004 02:01'!
barFat: aNum
	barFat _ aNum! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 05:43'!
barFlg
	^ barFlg! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 04:26'!
barFlg: aNum
	barFlg _ aNum! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 04:17'!
barHeight
	^ barHeight! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 04:25'!
barHeight: aHeight
	barHeight _ aHeight! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 16:42'!
barNarrow
	rotateFlg = 0
	ifTrue: [self barHeight: 10.
		bar height: 10.
		shrinkHeight _ 10.
		text1 align: text1 center with: (bar left + 20)@(bar center y).
		text2 align: text2 center with: bar center.
		text3 align: text3 center with: (bar right - 20)@(bar center y).
	]
	ifFalse: [self barWidth: 10.
		bar width: 10.
		shrinkWidth _ 10.
		text1 align: text1 center with: (bar center x)@(bar top + 20).
		text2 align: text2 center with: bar center.
		text3 align: text3 center with: (bar center x)@(bar bottom - 20).
	].
	! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 16:43'!
barNormal
	rotateFlg = 0
	ifTrue: [self barHeight: 25.
		bar height: 25.
		shrinkHeight _ 25.
		text1 align: text1 center with: (bar left + 20)@(bar center y).
		text2 align: text2 center with: bar center.
		text3 align: text3 center with: (bar right - 20)@(bar center y).
	]
	ifFalse: [self barWidth: 25.
		bar width: 25.
		shrinkWidth _ 25.
		text1 align: text1 center with: (bar center x)@(bar top + 20).
		text2 align: text2 center with: bar center.
		text3 align: text3 center with: (bar center x)@(bar bottom - 20).
	].
	! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 16:43'!
barWide
	rotateFlg = 0
	ifTrue: [self barHeight: 50.
		bar height: 50.
		shrinkHeight _ 50.
		text1 align: text1 center with: (bar left + 20)@(bar center y).
		text2 align: text2 center with: bar center.
		text3 align: text3 center with: (bar right - 20)@(bar center y).
	]
	ifFalse: [self barWidth: 50.
		bar width: 50.
		shrinkWidth _ 50.
		text1 align: text1 center with: (bar center x)@(bar top + 20).
		text2 align: text2 center with: bar center.
		text3 align: text3 center with: (bar center x)@(bar bottom - 20).
	].
	! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 05:47'!
barWidth
	^ barWidth! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 04:24'!
barWidth: aWidth
	barWidth _ aWidth! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 21:31'!
button2
	^ button2! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/18/2004 02:07'!
handlesMouseDown: anEvt 
	anEvt yellowButtonPressed
		ifTrue: [^ true].
	anEvt redButtonPressed
		ifTrue: [^ true].
	^ super handlesMouseDown: anEvt
! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 16:41'!
initialize
	super initialize.
	self extent: 50@50.
	self color: Color white.
	
	barFlg _ 0.
	barWidth _ 300.
	barHeight _ 25.
	rotateFlg _ 0.
	shrinkWidth _ 25.
	shrinkHeight _ 25.
	self makeParts
	! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/28/2004 00:04'!
makeParts
	| swp |
	bar _ RectangleMorph new.
	bar extent: 300@25.
	bar color: (Color r: 0.6 g: 0.68 b: 0.9 alpha: 0.7).
	bar borderWidth: 1.
	self addMorph: bar.
	bar align: bar topLeft with: self center.

	button1 _ EllipseMorph new.
	button1 extent: 20@20.
	button1 color: (Color r: 0.8 g: 0.8 b: 0.8).
	self addMorph: button1.
	button1 align: button1 center with: self center.
	button1 on: #doubleClick send: #value to: [
		(rotateFlg = 0)
		ifTrue: [
			(barFlg = 0)
			ifTrue: [
				swp _ barWidth.
				barWidth _ barHeight.
				barHeight _ swp.
				bar extent: (bar height)@(bar width).
				text1 align: text1 center with: (bar center x)@(bar top + 20).
				text2 align: text2 center with: bar center.
				text3 align: text3 center with: (bar center x)@(bar bottom - 20).
				button2 align: button2 center with: bar bottomLeft.
				text1 contents: '  L  '.
				text2 contents: '  C  '.
				text3 contents: '  R  ']
			ifFalse: [
				swp _ barWidth.
				barWidth _ barHeight.
				barHeight _ swp.
				button2 align: button2 center with: bar bottomLeft.
				text1 contents: '  L  '.
				text2 contents: '  C  '.
				text3 contents: '  R  '.
			].
			rotateFlg _ 1
		]
		ifFalse: [
			(barFlg = 0)
			ifTrue: [
				barWidth _ bar height.
				barHeight _ bar width.
				bar extent: (bar height)@(bar width).
				text1 align: text1 center with: (bar left + 20)@(bar center y).
				text2 align: text2 center with: bar center.
				text3 align: text3 center with: (bar right - 20)@(bar center y).
				button2 align: button2 center with: bar topRight.
				text1 contents: '  T  '.
				text2 contents: '  C  '.
				text3 contents: '  B  ']
			ifFalse: [
				barWidth _ bar height.
				barHeight _ bar width.
				button2 align: button2 center with: bar topRight.
				text1 contents: '  T  '.
				text2 contents: '  C  '.
				text3 contents: '  B  '.
			].
			rotateFlg _ 0
		]
	].

	button2 _ ToyAlignBtn new.
	button2 extent: 16@16.
	button2 color: Color black.
	bar addMorph: button2.
	button2 align: button2 bottomLeft with: bar topRight + (-10@10).

	text1 _ StringMorph new.
	text1 contents: '  T  '.
	bar addMorph: text1.
	text1 align: text1 center with: (bar left + 20)@(bar center y).
	text1 on: #click send: #value to: [
		self owner submorphs do: [ :m | 
			(bar bounds intersects: m bounds) ifTrue: [ 
				m = self ifFalse: [
					rotateFlg = 0 ifTrue: [m top: bar top]
								ifFalse: [m left: bar left]
				]]].
	].

	text2 _ StringMorph new.
	text2 contents: '  C  '.
	bar addMorph: text2.
	text2 align: text2 center with: bar center.
	text2 on: #click send: #value to: [
		self owner submorphs do: [ :m | 
			(bar bounds intersects: m bounds) ifTrue: [ 
				m = self ifFalse: [
					rotateFlg = 0 ifTrue: [m center: (m center x)@(bar center y)]
								ifFalse: [m center: (bar center x)@(m center y)]
				]]].
	].

	text3 _ StringMorph new.
	text3 contents: '  B  '.
	bar addMorph: text3.
	text3 align: text3 center with: (bar right - 20)@(bar center y).
	text3 on: #click send: #value to: [
		self owner submorphs do: [ :m | 
			(bar bounds intersects: m bounds) ifTrue: [ 
				m = self ifFalse: [
					rotateFlg = 0 ifTrue: [m bottom: bar bottom]
								ifFalse: [m right: bar right]
				]]].
	]
! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/18/2004 02:25'!
mouseDown: anEvt
	self on: #startDrag send: #grabMorph: to: self.
	anEvt hand waitForClicksOrDrag: self event: anEvt.

	anEvt yellowButtonPressed ifTrue: [
		self optionMenu].
	super mouseDown: anEvt
! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/18/2004 02:28'!
optionMenu
	| aMenu |
	aMenu _ MenuMorph new.
	aMenu addTitle: 'option menu'.
	aMenu addStayUpItem.
	aMenu add: 'bar narrow' target: self action: #barNarrow.
	aMenu add: 'bar nomal' target: self action: #barNormal.
	aMenu add: 'bar wide' target: self action: #barWide.
	aMenu popUpInWorld: World! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 02:32'!
rotateFlg
	^ rotateFlg! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 04:27'!
rotateFlg: aNum
	rotateFlg _ aNum! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 16:41'!
shrinkHeight
	^ shrinkHeight! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 16:41'!
shrinkWidth
	^ shrinkWidth! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 17:43'!
text1
	^ text1! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 17:43'!
text2
	^ text2! !

!ToyAlignment methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 17:43'!
text3
	^ text3! !


Morph subclass: #ToyCamera
	instanceVariableNames: 'box icon name space header finder cntrlPlate '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyTools'!

!ToyCamera methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 05:11'!
box
	^ box! !

!ToyCamera methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 05:10'!
header
	^ header! !

!ToyCamera methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 05:11'!
icon
	^ icon! !

!ToyCamera methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 06:38'!
initialize
	| fc shutBtn space2 |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ RectangleMorph new.
	box extent: 300@200.
	box color: Color transparent.
	box borderColor: Color black.
	box borderWidth: 1.
	box layoutPolicy: TableLayout new.
	box listDirection: #leftToRight.
	self addMorph: box.
	
	finder _ PasteUpMorph new.
	finder extent: 270@200.
	finder color: Color transparent.
	finder borderWidth: 0.
	finder layoutPolicy: TableLayout new.
	finder hResizing: #spaceFill.	
	finder vResizing: #spaceFill.
	box addMorph: finder.

	cntrlPlate _ RectangleMorph new.
	cntrlPlate extent: 30@200.
	cntrlPlate color: Color black.
	cntrlPlate borderColor: Color black.
	cntrlPlate borderWidth: 1.
	cntrlPlate layoutPolicy: TableLayout new.
	cntrlPlate wrapCentering: #center.
	cntrlPlate vResizing: #spaceFill.
	box addMorph: cntrlPlate.
	cntrlPlate goBehind.

	shutBtn _ EllipseMorph new.
	shutBtn extent: 20@20.
	shutBtn color: Color red.
	cntrlPlate addMorph: shutBtn.

	space2 _ Morph new.
	space2 color: Color transparent.
	space2 extent: 10@10.
	cntrlPlate addMorph: space2.

	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'ToyCamera'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ ToyIcon new.
	fc _ FormCanvas extent: 36@26.
	fc fillRectangle: ((0@0) extent: (36@26)) color: Color white.
	fc frameRectangle: ((0@0) corner: (36@26)) width: 2 color: Color black.

	fc frameRectangle: ((25@2) extent: (6@6)) width: 1 color: Color black.

	fc frameRectangle: ((0@6) corner: (36@26)) width: 1 color: Color black.
	fc frameOval: ((9@6) extent: (18@18)) width: 2 color: (Color black).
	fc frameOval: ((13@10) extent: (10@10)) width: 1 color: (Color black).
	fc form shapeFill: (Color r: 0.8 g: 0.8 b: 0.8) interiorPoint: (3@15).
	fc form shapeFill: (Color r: 0.8 g: 0.8 b: 0.8) interiorPoint: (30@15).
	icon form: fc form.
	header addMorph: icon.
! !

!ToyCamera methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 05:10'!
name
	^ name! !

!ToyCamera methodsFor: 'as yet unclassified' stamp: 'ty 8/20/2004 05:11'!
space
	^ space! !


Morph subclass: #ToyDropPic
	instanceVariableNames: 'box icon name space header dirName fileName fileType '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyTools'!

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/27/2004 07:17'!
acceptDroppingMorph: aMorph event: evt
	| fName fNum |
	(FileDirectory default directoryExists: dirName)
	ifFalse: 
		[FileDirectory default createDirectory: dirName.].

	fNum _ (FileDirectory default directoryNamed: dirName) fileNames size.
 	fNum _ (fNum + 1) asString.
	fName _ dirName,(FileDirectory pathNameDelimiter) asString, fileName , fNum , fileType.

	fileType = '.gif' ifTrue: [
		GIFReadWriter putForm: aMorph imageForm onFileNamed: fName].
	fileType = '.jpeg' ifTrue: [
		JPEGReadWriter2 putForm: aMorph imageForm onFileNamed: fName].
	fileType = '.bmp' ifTrue: [
		 aMorph imageForm writeBMPfileNamed: fName].

	aMorph rejectDropMorphEvent: evt.

! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:25'!
box
	^ box! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/14/2004 06:01'!
dirName
	^ dirName! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:37'!
dirName: aString
	dirName _ aString! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/14/2004 06:02'!
fileName
	^ fileName! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:38'!
fileName: aString
	fileName _ aString! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/14/2004 06:02'!
fileType
	^ fileType! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:38'!
fileType: aString
	fileType _ aString! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:25'!
header
	^ header! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:25'!
icon
	^ icon! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/18/2004 04:38'!
initialize
	| fc  rm |
	super initialize.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #shrinkWrap.	
	self vResizing: #shrinkWrap.

	box _ RectangleMorph new.
	box layoutPolicy: TableLayout new.
	box extent: 120@120.
	box color: Color white.
	box borderColor: Color black.
	box borderWidth: 1.
	self addMorph: box.
	
	rm _ RectangleMorph new.
	rm extent: 118@118.
	rm color: (Color r: 0.9 g: 0.9 b: 0.9 alpha: 0.3).
	rm borderWidth: 25.
	rm borderColor: Color black..
	rm setBorderStyle: #complexAltInset.
	rm layoutPolicy: TableLayout new.
	rm hResizing: #spaceFill.
	rm vResizing: #spaceFill.
	box addMorph: rm.
	rm align: rm topLeft with: box topLeft + (1@1).


	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'ToyDropPic'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ DropPicIcon new.
	fc _ FormCanvas extent: 40@40.
	fc fillRectangle: ((0@10) corner: (10@30)) color: Color white.
	fc fillRectangle: ((30@10) corner: (40@30)) color: Color white.
	fc fillRectangle: ((0@30) corner: (40@40)) color: Color white.

	fc line: 1@10 to: 10@10 width: 2 color: Color black.
	fc line: 10@10 to: 10@30 width: 2 color: Color black.
	fc line: 10@30 to: 30@30 width: 2 color: Color black.
	fc line: 30@30 to: 30@10 width: 2 color: Color black.
	fc line: 30@10 to: 39@10 width: 2 color: Color black.
	fc line: 39@10 to: 39@39 width: 2 color: Color black.
	fc line: 39@39 to: 0@39 width: 2 color: Color black.
	fc line: 1@39 to: 1@10 width: 2 color: Color black.

	fc line: 10@1 to: 30@1 width: 2 color: Color black.
	fc line: 30@1 to: 20@20 width: 2 color: Color black.
	fc line: 20@20 to: 10@1 width: 2 color: Color black.
	fc form shapeFill: (Color r: 0.8 g: 0.8 b: 0.8) interiorPoint: (20@5).

	icon form: fc form.
	header addMorph: icon.

	dirName _ 'myPicture'.
	fileName _ 'img'.
	fileType _ '.gif'.! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:25'!
name
	^ name! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 00:26'!
space
	^ space! !

!ToyDropPic methodsFor: 'as yet unclassified' stamp: 'ty 8/14/2004 05:43'!
wantsDroppedMorph: aMorph event: evt
	^ true.! !


Morph subclass: #ToyPicViewer
	instanceVariableNames: 'box icon name space header dirName fileType fileNameStock listBox listBase cntrlBox thumbBank hNum vNum lNum nextBtn reLoadBtn prevBtn dirText folderBtn '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyTools'!

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 03:39'!
box
	^ box! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 03:40'!
header
	^ header! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 03:39'!
icon
	^ icon! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 2/10/2005 20:18'!
initialize
	| fc |
	super initialize.

	dirName _ 'myPicture'.
	fileType _ '.gif'.
	fileNameStock _ OrderedCollection new.
	thumbBank _ OrderedCollection new.

	self color: Color transparent.
	self layoutPolicy: TableLayout new.
	self listDirection: #leftToRight.
	self wrapDirection: #topToBottom.
	self hResizing: #spaceFill.	
	self vResizing: #shrinkWrap.

	box _ RectangleMorph new.
	box layoutPolicy: TableLayout new.
	box listDirection: #leftToRight.
	box wrapDirection: #topToBottom.
	box hResizing: #shrinkWrap.
	box vResizing: #shrinkWrap.
	box extent: 300@230.
	box color: Color white.
	box borderColor: Color black.
	box borderWidth: 1.
	box clipSubmorphs: true.
	self addMorph: box.

	self makeControlBox.
	self makeListBox.
	self loadPictuer.

	header _ Morph new.
	header color: Color transparent.
	header layoutPolicy: TableLayout new.
	header listDirection: #leftToRight.
	header hResizing: #shrinkWrap.
	header vResizing: #shrinkWrap.
	self addMorph: header.

	name _ TextMorph new.
	name contents: 'ToyPicViewer'.
	name wrapFlag: true.
	header addMorph: name.
	name lockUnlockMorph.

	space _ Morph new.
	space extent: 10@10.
	space color: Color transparent.
	header addMorph: space.

	icon _ ToyIcon new.
	fc _ FormCanvas extent: 36@36.
	fc fillOval: ((0@0) extent: (36@36)) color: (Color white).
	fc frameOval: ((1@1) extent: (35@35)) width: 2 color: (Color black).
	fc frameOval: ((7@7) extent: (23@23)) width: 1 color: (Color black).
	fc frameOval: ((8@14) extent: (21@10)) width: 1 color: (Color black).
	fc fillOval: ((15@15) extent: (8@8)) color: (Color black).
	fc form shapeFill: (Color r: 0.8 g: 0.8 b: 0.8) interiorPoint: (18@9).
	fc form shapeFill: (Color r: 0.8 g: 0.8 b: 0.8) interiorPoint: (18@28).
	icon form: fc form.
	header addMorph: icon.
! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 2/8/2005 01:37'!
listBase
	^ listBase! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 9/7/2004 02:00'!
listBox
	^ listBox! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 2/7/2005 03:01'!
loadPictuer
| slash dir dirPath thumb | 
slash _ FileDirectory slash.
dirPath _ (FileDirectory default pathName), slash, dirName, slash.
dir _ FileDirectory on: dirPath.
dir fileNames withIndexDo: [:fname :fid  | 
(fname asLowercase endsWith: '.gif') | (fname asLowercase endsWith: '.jpeg') |  (fname asLowercase endsWith: '.jpg') | (fname asLowercase endsWith: '.bmp')
ifTrue: [
	fileNameStock add: fname.
	thumb _ ((ToyThumbButton new maxWidth: 50 minHeight: 40)
	makeThumbnailFromForm:
		(Form fromFileNamed: dirPath, fname)).
	thumb setDirPath: dirPath.
	thumb text1 contents: fname.
	thumbBank add: thumb.
	"--------------------------------------------------"
	listBox addMorph: thumb.
	thumb goBehind.
	thumb text1 align: thumb text1 center with: (thumb center x)@(thumb bottom + 8).
	"-------------------------------------------------"
 ]]! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 2/10/2005 20:13'!
makeControlBox
	| fc space2 m dir dirPath|
	cntrlBox _ RectangleMorph new.
	cntrlBox layoutPolicy: TableLayout new.
	cntrlBox listDirection: #leftToRight.
	cntrlBox hResizing: #spaceFill.
	cntrlBox cellInset: 5@0.
	cntrlBox layoutInset: 5@0.
	cntrlBox extent: 300@20.
	cntrlBox color: Color black.
	cntrlBox borderColor: Color black.
	cntrlBox borderWidth: 1.
	box addMorph: cntrlBox.


	nextBtn _ PolygonMorph new.
	nextBtn setVertices: {0@0. 8@10. 16@0.}.
	nextBtn color: (Color r: 1.0 g: 0.903 b: 0.0).
	nextBtn borderColor: Color black.
	nextBtn borderWidth: 1.
	nextBtn on: #mouseStillDown send: #value to: [listBox top: listBox top - 8.
										listBox bottom <= listBase bottom ifTrue: [
																listBox bottom: listBase bottom]].
	cntrlBox addMorph: nextBtn.

	space2 _ Morph new.
	space2 color: Color transparent.
	space2 extent: 5@ 10.
	cntrlBox addMorph: space2.


	reLoadBtn _ EllipseMorph new.
	reLoadBtn color: Color red.
	reLoadBtn extent: 14@14.
	reLoadBtn on: #click send: #value to: [
											listBox removeAllMorphs.
											self loadPictuer.].
	cntrlBox addMorph: reLoadBtn.

	space2 _ Morph new.
	space2 color: Color transparent.
	space2 extent: 5@ 10.
	cntrlBox addMorph: space2.


	prevBtn _ PolygonMorph new.
	prevBtn setVertices: {0@0. 8@-10. 16@0.}.
	prevBtn color: (Color r: 0.129 g: 0.613 b: 0.0).
	prevBtn borderColor: Color black.
	prevBtn borderWidth: 1.
	prevBtn on: #mouseStillDown send: #value to: [listBox top: listBox top + 8.
										listBox top > listBase top ifTrue: [
																listBox top: listBase top]].
	cntrlBox addMorph: prevBtn.

	space2 _ Morph new.
	space2 color: Color transparent.
	space2 extent: 100@ 10.
	cntrlBox addMorph: space2.


	dirText _ TextMorph new.
	dirText contents: dirName.
	dirText textColor: Color white.
	cntrlBox addMorph: dirText.

	folderBtn _ SketchMorph new.
	fc _ FormCanvas extent: 18@18.
	fc fillRectangle: ((0@3) extent: (18@14)) color: Color white.
	fc frameRectangle: ((0@3) extent: (18@14)) width: 1 color: Color black.
	fc fillRectangle: ((0@0) extent: (10@4)) color: Color white.
	fc frameRectangle: ((0@0) extent: (10@4)) width: 1 color: Color black.
	folderBtn form: fc form.
	folderBtn on: #click send: #value to: [m _ CustomMenu new.
								dirPath _ FileDirectory default pathName.
								dir _ FileDirectory on: dirPath.
								dir directoryNames do: [:dname  | m add: dname action: dname].
								dirName _ m startUp.
								dirText contents: dirName.
								listBox removeAllMorphs.
								self loadPictuer.].
	cntrlBox addMorph: folderBtn! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 2/9/2005 19:59'!
makeListBox
	listBase _ RectangleMorph new.
	listBase extent: 300@230.
	listBase color: Color white.
	listBase borderColor: Color black.
	listBase borderWidth: 1.
	listBase clipSubmorphs: true.
	box addMorph: listBase.

	listBox _ RectangleMorph new.
	listBox layoutPolicy: TableLayout new.
	listBox listDirection: #leftToRight.
	listBox wrapDirection: #topToBottom.
	listBox hResizing: #spaceFill.
	listBox vResizing: #shrinkWrap.
	listBox cellInset: 10@10.
	listBox layoutInset: 5@5.
	listBox extent: 300@1000.
	listBox color: Color white.
	listBox borderColor: Color black.
	listBox borderWidth: 0.
	listBox changeClipSubmorphs.
	listBase addMorph: listBox.! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 03:39'!
name
	^ name! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 8/15/2004 03:39'!
space
	^ space! !

!ToyPicViewer methodsFor: 'as yet unclassified' stamp: 'ty 9/7/2004 01:58'!
thumbBank
	^ thumbBank! !


Thumbnail subclass: #ToyThumbButton
	instanceVariableNames: 'text1 dirPath thumbName fileType '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tToyTools'!

!ToyThumbButton methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 00:49'!
fileType: aType
	fileType _ aType! !

!ToyThumbButton methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 22:19'!
handlesMouseDown: anEvent
	^ true
! !

!ToyThumbButton methodsFor: 'as yet unclassified' stamp: 'ty 8/18/2004 03:41'!
initialize
	super initialize.
	text1 _ TextMorph new.
	text1 wrapFlag: true.
	text1 lockUnlockMorph.
	self addMorph: text1.
	text1 align: text1 center with: (self center x)@(self bottom + 8).
! !

!ToyThumbButton methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 01:53'!
mouseDown: evt
	| img  sk |
	self setThumbName: self text1 contents asString.
	(thumbName endsWith: '.gif') ifTrue: [
	img _ Form fromFileNamed: dirPath , thumbName].
	(thumbName endsWith: '.jpeg')
	ifTrue: [
	img _ Form fromFileNamed: dirPath , thumbName].
	(thumbName endsWith: '.jpg')
	ifTrue: [
	img _ Form fromFileNamed: dirPath , thumbName].
	(thumbName endsWith: '.bmp')
	ifTrue: [
	img _ Form fromFileNamed: dirPath , thumbName].
	sk _ SketchMorph new form: img.
	sk openInHand.! !

!ToyThumbButton methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 22:18'!
setDirPath: aPath
	dirPath _ aPath.! !

!ToyThumbButton methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 01:42'!
setThumbName: aFileName
	thumbName _ aFileName.! !

!ToyThumbButton methodsFor: 'as yet unclassified' stamp: 'ty 8/16/2004 23:36'!
text1
	^ text1! !

!ToyThumbButton methodsFor: 'as yet unclassified' stamp: 'ty 8/17/2004 01:41'!
thumbName
	^ thumbName! !